#!/bin/sh
#########################################################################
#  This script is to be "sourced" to set the paths to fvs scripts and	#
#  executable files using the files on the NCO server.			#
#									#
#  Log:									#
#  K. Brill/HPC      20120423	Created					#
#########################################################################

if [ ${OPSDIR:-null} = "null" ]; then
    cat << EOF

    Environment variable \$OPSDIR must be set.

    Cannot complete setup for vsdb-fvs.

EOF
    exit
fi

if [ ${OS:-null} = "null" ]; then
    cat << EOF

        WARNING ---------->>

	NAWIPS paths and environment variables must be set first.

        Only fvs DEV=TX will work.

EOF
    OS=`uname`
    export OS
fi

type mkplot_vsdb > /dev/null 2>&1
if [ $? -ne 0 ]; then
    cat << EOF

    The fvs executables are not in the path.
    Make sure the opsdir path is set correctly -- check with Keith.

EOF
fi

VSDB=$OPSDIR/vsdb;export VSDB
VSDB_TBL=$VSDB/tables
VSDB_HLP=$VSDB/help
VSDB_SCRIPTS=$VSDB/scripts
VSDB_DAY1=199001010000
VSDB_TEMP=/tmp
export VSDB_TBL VSDB_HLP VSDB_SCRIPTS VSDB_DAY1 VSDB_TEMP
DDAPP=$VSDB/ddapp;export DDAPP

#  Note:  Executable files are not under $VSDB/ddapp.  They are
#         located under $OPSDIR/bin.

PATH="$PATH:$VSDB/scripts"
export PATH

if [ ${GEMEXE:-null} = null ]; then
    gplt_path=`type gplt | cut -d" " -f3`
    GEMEXE=`dirname $gplt_path`
    export GEMEXE
fi
