	SUBROUTINE CPB_NRPS ( mxt, mxd, ndpth, npts, itrc, dtrace,
     +			      rmiss, trcdat, trcmin, trcmax, iret )
C************************************************************************
C* CPB_NRPS								*
C*									*
C* This subroutine computes the negative Ranked Probability Score	*
C* fraction.  This is the no-skill fraction.				*
C*									*
C* CPB_NRPS ( MXT, MXD, NDPTH, NPTS, ITRC, DTRACE, RMISS,		*
C*	      TRCDAT, TRCMIN, TRCMAX, IRET )				*
C*									*
C* Input parameters:							*
C*	MXT		INTEGER		Max # of traces in DTRACE	*
C*	MXD		INTEGER		Max # of values/point in DTRACE	*
C*	NDPTH		INTEGER		Number of values/point		*
C*	NPTS		INTEGER		Number of points in the trace	*
C*	ITRC		INTEGER		Trace #				*
C*	DTRACE (MXT,MXD,						*
C*		NPTS)	REAL*8		Trace values			*
C*	RMISS		REAL		Missing value for output	*
C*									*
C* Output parameters:							*
C*	TRCDAT (NPTS)	REAL*8		Output trace			*
C*	TRCMIN		REAL		Minimum output trace value	*
C*	TRCMAX		REAL		Maximum output trace value	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/HPC		03/04						*
C************************************************************************
	REAL*8		dtrace (mxt,mxd,*), trcdat (*)
C*
C*-----------------------------------------------------------------------
	iret = 0
C*
	trcmin = 0.0
	trcmax = 1.0
	DO ip = 1, npts
	    IF ( dtrace (itrc,3,ip) .gt. 0.0 .and.
     +		 dtrace (itrc,1,ip) .gt. 0.0 ) THEN
		trcdat (ip) = 1.0 -
     +			      dtrace (itrc,3,ip) / dtrace (itrc,1,ip)
		IF ( trcdat (ip) .gt. 1.0 ) trcdat (ip) = 1.0
		IF ( trcdat (ip) .lt. 0.0 ) trcdat (ip) = 0.0
	    ELSE
		trcdat (ip) = rmiss
	    END IF
	END DO
C*
	RETURN
	END
