	SUBROUTINE CS_PCBC ( trcd, npts, rmiss, trcdat, trcmin, trcmax,
     +			     iret )
C************************************************************************
C* CS_PCBC								*
C*									*
C* This subroutine computes the % contribution toward the total count	*
C* of each threshold range.						*
C*									*
C* CS_PCBC ( TRCD, NPTS, RMISS, TRCDAT, TRCMIN, TRCMAX, IRET )		*
C*									*
C* Input parameters:							*
C*	TRCD (NPTS)	REAL*8		Trace data input (counts)	*
C*	NPTS		INTEGER		Number of trace points		*
C*	RMISS		REAL		Missing value for output	*
C*									*
C* Output parameters:							*
C*	TRCDAT (NPTS)	REAL*8		Output trace			*
C*	TRCMIN		REAL		Minimum output trace value	*
C*	TRCMAX		REAL		Maximum output trace value	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/HPC		 3/01						*
C************************************************************************
	REAL*8		trcd (*), trcdat (*)
C*
	REAL*8		ttlcnt
C*-----------------------------------------------------------------------
	iret = 0
	trcmin = 1.1E30
	trcmax = -1.1E30
	ttlcnt = 0.0
	DO ip = 1, npts-1
	    IF ( trcd (ip)  .gt. -1.E30 ) THEN
		trcdat (ip) = trcd (ip) - trcd (ip+1)
		ttlcnt = ttlcnt + trcdat (ip)
	    ELSE
		trcdat (ip) = rmiss
	    END IF
	END DO
	IF ( trcd (npts) .gt. -1.E30 ) THEN
	    trcdat (npts) = trcd (npts)
	    ttlcnt = ttlcnt + trcdat (npts)
	ELSE
	    trcdat (npts) = rmiss
	END IF
	DO ip =1, npts
	    IF ( trcd (ip) .gt. -1.E30 .and. ttlcnt .gt. 0.0 ) THEN
		trcdat (ip) = trcdat (ip) * 100. / ttlcnt
		IF ( trcdat (ip) .gt. trcmax )
     +			trcmax = trcdat (ip)
		IF ( trcdat (ip) .lt. trcmin )
     +			trcmin = trcdat (ip)
	    ELSE
		trcdat (ip) = rmiss
	    END IF
	END DO
C*
	RETURN
	END
