	SUBROUTINE PLT_ADRL ( sclm, iret )
C************************************************************************
C* PLT_ADRL								*
C*									*
C* This subroutine adds the reference lines to an attribute diagram.	*
C*									*
C* PLT_ADRL  ( SCLM, IRET )						*
C*									*
C* Input parameters:							*
C*	SCLM		REAL		Sample climatological frequency *
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Relayed return code		*
C*				 	  0 = normal			*
C**									*
C* Log:									*
C* K. Brill/HPC      20070124						*
C************************************************************************
	INCLUDE         'plt.cmn'
C*
	REAL		x(2), y(2)
C*------------------------------------------------------------------------
	iret = 0
	nline = MAXLIN
	icsv = ilcolr (nline)
	itsv = ildash (nline)
	iwsv = ilwdth (nline)
	insv = nlines
	nlines = nline
C*
	DO i = 1, 4
	    IF ( iadlnc (i) .gt. 0 ) THEN
	        ilcolr (nline) = iadlnc (i)
	        ildash (nline) = iadlnt (i)
	        ilwdth (nline) = iadlnw (i)
		IF ( i .eq. 1 ) THEN
C
C*		    Add the vertical climo frequency line.
C
		    x (1) = sclm
		    y (1) = yaxbeg
		    x (2) = sclm
		    y (2) = yaxend
	            CALL PLT_GLIN ( nline, 'M', 2, x, y, iret )
		ELSE IF ( i .eq. 2 ) THEN
C
C*		    Add the perfect reliability line , y=x.
C
		    x (1) = xaxbeg
		    y (1) = xaxbeg
		    x (2) = xaxend
		    y (2) = xaxend
	            CALL PLT_GLIN ( nline, 'M', 2, x, y, iret )
		ELSE IF ( i .eq. 3 ) THEN
C
C*		    Add the skill/no-skill line.  The equation for
C*		    this line is y = .5x + .5*sclm
C
		    x (1) = xaxbeg
		    y (1) = .5 * xaxbeg + .5 * sclm
		    x (2) = xaxend
		    y (2) = .5 * xaxend + .5 * sclm
	            CALL PLT_GLIN ( nline, 'M', 2, x, y, iret )
		ELSE
C
C*		    Add the horizontal climo frequency line.
C
		    x (1) = xaxbeg
		    y (1) = sclm
		    x (2) = xaxend
		    y (2) = sclm
	            CALL PLT_GLIN ( nline, 'M', 2, x, y, iret )
		END IF
	    END IF
	END DO
C*
	ilcolr (nline) = icsv
	ildash (nline) = itsv
	ilwdth (nline) = iwsv
	nlines = insv
C*
	RETURN
	END
