	SUBROUTINE PLT_CRPF ( mp, mt, ntrc, npts, trc, iret )
C************************************************************************
C* PLT_CRPF								*
C*									*
C* This subroutine ranks the first trace values among the remaining	*
C* traces at each point.  If the first trace has the highest value	*
C* at point n, the TRC(n,1) = 1.  If it is the second highest value	*
C* then TRC(n,1) = 2, and so on.					*
C*									*
C* PLT_CRPF  ( MP, MT, NTRC, NPTS, TRC, IRET )				*
C*									*
C* Input parameters:							*
C*	MP		INTEGER		Maximum points on a trace	*
C*	MT		INTEGER		Maximum number of traces	*
C*	NTRC		INTEGER		Number of traces to plot	*
C*	NPTS (MT)	INTEGER		Number of trace points		*
C*									*
C* Input and Output parameter:						*
C*	TRC (MP,MT)	REAL		Trace data			*
C*					TRC (*,1) = rank on output	*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					-26 = only one trace		*
C*					-27 = trace pt cnts differ	*
C**									*
C* Log:									*
C* K. Brill/HPC		05/01						*
C************************************************************************
	INCLUDE		'plt.cmn'
C*
	PARAMETER	( RMISSD = -9999.  )
	PARAMETER	( RDIFFD =  0.1    )
C*
	REAL		trc (mp,mt)
	INTEGER		npts (*)
	LOGICAL		chkit
	LOGICAL		ERMISS
C*
	ERMISS (xxxx) = ( ABS ( xxxx - RMISSD ) .lt. RDIFFD )
C*-----------------------------------------------------------------------
	iret = 0
C*
	IF ( ntrc .lt. 2 ) THEN
	    iret = -26
	    CALL PLT_ERRO ( iret, ' ', ier )
	    RETURN
	END IF
C*
	np = npts (1)
	chkit = .true.
	i = 1
	DO WHILE ( chkit .and. i .lt. ntrc )
	    i = i + 1
	    chkit = ( npts (i) .eq. np )
	END DO
	IF ( .not. chkit ) THEN
	    iret = -27
	    CALL PLT_ERRO ( iret, ' ', ier )
	    RETURN
	END IF
C*	
	DO ip = 1, np
	    IF ( .not. ERMISS ( trc(ip,1) ) ) THEN
		nrank = ntrc
		chkit = .true.
		it = 1
		DO WHILE ( it .lt. ntrc .and. chkit )
		    it = it + 1
		    IF ( .not. ERMISS ( trc(ip,it) ) ) THEN
			IF ( trc (ip,1) .ge. trc (ip,it) )
     +			nrank = nrank - 1
		    ELSE
			chkit = .false.
		    END IF
		END DO
		IF ( chkit ) THEN
		    trc (ip,1) = FLOAT ( nrank )
		ELSE
		    trc (ip,1) = RMISSD
		END IF
	    END IF
	END DO
C*
	RETURN
	END
