	SUBROUTINE PLT_GBDR  ( iclrsv, iret )
C************************************************************************
C* PLT_GBDR								*
C*									*
C* This subroutine sets the color and line type for axes and borders	*
C* of a plot.								*
C*									*
C* The relevant control file entry is formatted as follows:		*
C*									*
C*	BORDER = Background lines color/dash/width			*
C*									*
C* PLT_GBDR  ( ICLRSV, IRET )						*
C*									*
C* Output parameters:							*
C*	ICLRSV		INTEGER		Original color number		*
C*					-1 if ibcolr is 0.		*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C*					-14 = GEMPLT error		*
C**									*
C* Log:									*
C* K. Brill/EMC		 1/98						*
C* K. Brill/EMC		 4/99	Documentation				*
C* K. Brill/HPC		06/07	Return ICLRSV = -1 if ibcolr is 0	*
C************************************************************************
	INCLUDE		'plt.cmn'
C*
C------------------------------------------------------------------------
	iret = 0
	iclrsv = -1
C
C*	If color number is zero, do not do anything.
C
	IF ( ibcolr .le. 0 ) RETURN
C
C*	Set border color.
C
	CALL GQCOLR ( iclrsv, ier )
	CALL GSCOLR ( ibcolr, ier )
C
C*	Set border line attributes.
C
	CALL GSLINE ( ibdash, 0, ibwdth, 0, ierrg )
	IF ( ierrg .ne. 0 ) THEN
	    CALL PLT_PERR ( ierrg, iret )
	    CALL GSCOLR ( iclrsv, ier )
	    RETURN
	END IF
C*
	RETURN
	END
