	SUBROUTINE PLT_INIT  ( numtrc, libw, iret )
C************************************************************************
C* PLT_INIT								*
C* 									*
C* This subroutine initializes the graphics common data structure.	*
C* software.								*
C*									*
C* PLT_INIT  ( NUMTRC, LIBW, IRET )					*
C*									*
C* Input parameters:							*
C*	NUMTRC		INTEGER		Number of traces for display	*
C*	LIBW		LOGICAL		Flag to initialize BXWSKR	*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*					   0 = Normal return		*
C**									*
C* Log:									*
C* K. Brill/EMC		 1/98						*
C* K. Brill/EMC		 5/98	Add witness line structure init		*
C* K. Brill/EMC		 5/98	Initialize XAXUDL and NAXUDL		*
C* K. Brill/EMC		10/98	Initialize UNTTAX and INCTAX		*
C* K. Brill/EMC		 1/99	Initialize NXCHAR and NYCHAR		*
C* K. Brill/EMC		 4/99	Initialize LTRAVG, REVERS		*
C* K. Brill/HPC		 3/01	Changes for right-side yaxis		*
C* K. Brill/HPC		 3/03	Initialize COLORS			*
C* K. Brill/HPC		 5/03	Initialize USRLBL & /uline/ elements	*
C* K. Brill/HPC		 3/04	Initialize IHSTCL, BARWTH, & NHSTGM	*
C* K. Brill/HPC		 3/04	Initialize TALAGD			*
C* K. Brill/HPC		 5/04	Changed talagd to dornkh		*
C* K. Brill/HPC		 5/05	Initialize DODD2T			*
C* K. Brill/HPC      20070125   Initialize ATTRIB common variables	*
C* K. Brill/HPC	     20060619   Initialize SIGTST common var sercor;	*
C*				Change devstr=' ' to devstr='TX'	*
C* K. Brill/HPC      20120316	Initialize BXWSKR common elements	*
C* K. Brill/HPC      20120322   Add LIBW flag to initialize BXWSKR	*
C* K. Brill/HPC      20120402	Initialize bxwfnd			*
C* K. Brill/HPC      20120416   Initialize bxshft			*
C* K. Brill/HPC      20120420   Initialize lunbxw			*
C* K. Brill/HPC      20120615   Initialize BXWBTX common block		*
C* K. Brill/HPC      20120626   Final form for BXWBTX common block	*
C* K. Brill/WPC      20140919   Initialize sbxlen(*,*,1 & 2)            *
C* K. Brill/IMSG     20150521   Initialize wskflg as .false.            *
C* K. Brill/IMSG     20160726   Initialize twocol as .false.            *
C************************************************************************
	INCLUDE		'plt.cmn'
C*
	LOGICAL		libw
C*
C------------------------------------------------------------------------
	iret = 0
C
C*	Initialize the data structure.
C

	lablev = 1
	ptitle = ' '
	DO i = 1, MAXLIN
	    trclbl (i) = ' '
	    usrlbl (i) = .false.
	    ltravg (i) = .false.
	END DO
	xaxlbl = ' '
	nxchar = 1
	yaxlbl = ' '
	yrxlbl = ' '
	nychar = 1
	nychrr = 1
	sngltr = .false.
        twocol = .false.
C*
	ibcolr = 1
	ibdash = 1
	ibwdth = 1
C*
	lclear = .true.
C*
	devstr = 'TX'
	colors = ' '
	luntxt = 0
	lunbxw = 0
C*
	sfctor = 1.0
	rfctor = 1.0
C*
	nlines = numtrc
	DO i = 1, MAXLIN
	    ilcolr (i) = 1
	    ildash (i) = i
	    ilwdth (i) = 1
	    illbls (i) = 1
	END DO
C*
	DO i = 1, 4
	    iadlnc (i) = 1
	    iadlnt (i) = 2
	    iadlnw (i) = 1
	END DO
	ctmrng = ' '
C*
	nmrkrs = numtrc
	DO i = 1, MAXLIN
	    imcolr (i) = 1
	    imtype (i) = i
	    rmsize (i) = 1.0
	    imwdth (i) = 1
	END DO
C*
	view (1) = 0.
	view (2) = 0.
	view (3) = 1.
	view (4) = 1.
C*
	iyaxis = 1
	iyrxis = 1
	aspect = 0.0
	DO i = 1, 4
	    rmlbrt (i) = 0.
	END DO
C*
	tcslab = '1/1/1/SW'
C*
	DO i = 1, 3
	    tcsttl (i) = '1/1/1/SW'
	END DO
C*
	nwline = 0
	DO i = 1, MAXLIN
	    iwcolr (i) = 0
	    iwdash (i) = 0
	    iwwdth (i) = 0
	    rwvals (i) = 0.
	END DO
C*
	nrline = 0
	DO i = 1, MAXLIN
	    ircolr (i) = 0
	    irdash (i) = 0
	    irwdth (i) = 0
	    rrvals (i) = 0.
	END DO
C*
	nulpts = 0
	iulclr = 0
	iuldsh = 1
	iulwth = 1
	DO i = 1, MAXUDX
	    rulxvl (i) = 0.0
	    rulyvl (i) = 0.0
	END DO
C*
	xaxbeg = 0.0
	xaxend = 0.0
	DO i = 1, MAXVAL
	    xaxval (i) = 0.0
	END DO
	nxaxvl = 0
	DO i = 1, MAXUDX
	    xaxudl (i) = ' '
	END DO
	naxudl = 0
	ilbfrx = 1
	iglfrx = 0
	itmfrx = 1
	itmbtw = 0
	unttax = 'D'
	inctax = 1
	revers = .false.
	dornkh = .false.
	dodd2t = .false.
C*
	ifstls = 1
	yaxbeg = 0.0
	yaxend = 0.0
	DO i = 1, MAXVAL
	    yaxval (i) = 0.0
	END DO
	nyaxvl = 0
	ilbfry = 1
	iglfry = 0
	itmfry = 1
C*
	DO i = 1, MXTRCS
	    rhttrc (i) = .false.
	END DO
	rhtdrw = .false.
	ifstrs = 1
	yrxbeg = 0.0
	yrxend = 0.0
	DO i = 1, MAXVAL
	    yrxval (i) = 0.0
	END DO
	nyrxvl = 0
	ilrfry = 1
	igrfry = 0
	itrfry = 1
C*
	DO i = 1, MAXLIN
	    ihstcl (i) = 0
	END DO
	barwth = 0.0
	nhstgm = 0
C*
	sercor = .true.
C*
	IF ( libw ) THEN
	    ibxplt = 1
            kntrcs = 0
	    DO j = 1, MXTRCS
	        DO i = 1, MAXUDX
		    sbxlen (i,j,1) = 0.0
		    sbxlen (i,j,2) = 0.0
		    wskrmx (i,j) = 0.0
		    wskrmn (i,j) = 0.0
	        END DO
	        ktrcnm (j) = 0
	        kopcod (j) = 0
	    END DO
	    DO i = 1, MAXLIN
	        ibxclr (i) = 0
	        ibxlwd (i) = 0
	    END DO
	    nbxerr = 0
	    DO i = 1, MAXERR
	        ibxerr (i) = 0
	    END DO
	    npairs = 0
	    knmucc = 0
	    bxplvl = .05
	    nsmpls = 2000
	    wskflg = .false.
	    boxspc = 0.0
	    bxwflg = .false.
	    bxwfnd = .false.
	    bxshft = .false.
C
C*	    BXWBTX:
C
	    itxclr = 0
	    xlltbx = -9999.0
	    ylltbx = -9999.0
	    lgctbx = .false.
	    tcsbxw = ' '
	    bxbflg = .false.
	END IF
C*	
	RETURN
	END
