	SUBROUTINE PLT_MTTL ( fld, nfld, lbl, nlns, nhave, clbl, lng,
     +			      iret )
C************************************************************************
C* PLT_MTTL								*
C*									*
C* This subroutine adds character strings to a title or trace label	*
C* string using input arrays of general or specific trace label data.	*
C*									*
C* PLT_MTTL  ( FLD, NFLD, LBL, NLNS, NHAVE, CLBL, IRET )		*
C*									*
C* Input parameters:							*
C*	FLD (NLNS)	CHAR*(*)	Header field name		*
C*	NFLD (NLNS)	INTEGER		Header field number		*
C*	LBL (NLNS)	CHAR*(*)	Header field contents		*
C*	NLNS		INTEGER		Number of fields		*
C*	NHAVE		INTEGER		Number of field already used	*
C*									*
C* Input and output paramters:						*
C*	CLBL		CHAR*		Output title string		*
C*	LNG		INTEGER		Length of output string		*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					 +6 = invalid LABLEV value	*
C**									*
C* Log:									*
C* K. Brill/EMC		10/98						*
C************************************************************************
	CHARACTER*(*)	clbl, lbl (*), fld (*)
	INTEGER		nfld (*)
C*
	LOGICAL		found
C*
	INTEGER		iarchy (10)
	DATA		iarchy / 12, 10, 2, 3, 8, 9, 13, 14, 11, 6 /
	DATA		narchy / 10 /
	SAVE		narchy, iarchy
C*-----------------------------------------------------------------------
	iret = 0
C
C*	    Search the hierarchy of labels to fill out title.
C
	    iarc = 0
	    ier = 0
	    DO WHILE ( iarc .lt. narchy .and. ier .eq. 0 )
		iarc = iarc + 1
		ifnd = iarchy ( iarc )
		i = 0
		igot = 0
		DO WHILE ( i .lt. nlns .and. igot .eq. 0 )
		    i = i + 1
		    IF ( nfld (i) .eq. ifnd .and.
     +	                 nfld (i) .ne. nhave ) THEN
			CALL PLT_ADLB ( fld (i), lbl (i), clbl,
     +				        lng, ier )
			igot = ifnd
		    END IF
		END DO
	    END DO
C
C*	    Use non-hierarchy labels.
C
	    DO i = 1, nlns
		found = .false.
		iarc = 0
		DO WHILE ( iarc .lt. narchy .and. .not. found )
		    iarc = iarc + 1
		    found = ( nfld (i) .eq. iarchy (iarc) )
		END DO
		IF ( .not. found ) THEN
		    CALL PLT_ADLB ( fld (i), lbl (i), clbl, lng, ier )
		END IF
	    END DO
C*
	RETURN
	END
