	SUBROUTINE PLT_WRTX ( lun, nchrx, ioffx, string, iret )
C************************************************************************
C* PLT_WRTX								*
C*									*
C* This subroutine writes a character string as lines of text.		*
C*									*
C* IOFFX is interpreted as follows:					*
C*									*
C*  IOFFX		Action						*
C*   < 0	Center the output substring lines			*
C*  >= 0        This many blank characters precede each line		*
C*									*
C*									*
C* PLT_WRTX  ( LUN, NCHRX, IOFFX, STRING, IRET )			*
C*									*
C* Input parameters:							*
C*	LUN		INTEGER		Unit for output			*
C*	NCHRX		INTEGER		Maximum # of chars per line	*
C*	IOFFX		INTEGER		Offset or margin control	*
C*	STRING		CHAR*		Character string to print	*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					-23 = write error		*
C**									*
C* Log:									*
C* K. Brill/EMC		 1/99						*
C* K. Brill/HPC      20120420	Write to LUN not LUNTXT			*
C* K. Brill/WPC      20140709   Change itend=lng+1 to itend + mxchr     *
C************************************************************************
	INCLUDE		'plt.cmn'
C*
	CHARACTER*(*)	string
C*
	CHARACTER*132	record
C*-----------------------------------------------------------------------
	iret = 0
	mxchr = nchrx
	IF ( mxchr .gt. 128 ) mxchr = 128
	CALL ST_LSTR ( string, lng, ier )
	IF ( lng .gt. 0 ) THEN
	    IF ( lng .le. mxchr ) THEN
		IF ( ioffx .lt. 0 ) THEN
		    ixoff = ( mxchr - lng ) / 2
		ELSE
		    ixoff = ioffx
		END IF
		record = ' '
		record ( ixoff+1:ixoff+lng ) = string (1:lng)
		WRITE (lun,'(A)',IOSTAT=ios) record (1:ixoff+lng)
		IF ( ios .ne. 0 ) THEN
		    iret = -23
		    RETURN
		END IF
	    ELSE
		itend = 0
		istrt = 1
		nclft = lng
		DO WHILE ( itend .lt. lng )
		    IF ( nclft .gt. mxchr ) THEN
			ic = itend + mxchr
			DO WHILE ( ic .gt. 1 )
			    ic = ic - 1
			    IF ( string (ic:ic) .eq. ' ' ) THEN
				isplit = ic
				ic = -9
			    END IF
			END DO
			IF ( ic .eq. -9 ) THEN
			    itend = isplit
			ELSE
                            itend = itend + mxchr
			END IF
		    ELSE
			itend = lng + 1
		    END IF
		    nchrs = itend - istrt
		    IF ( ioffx .lt. 0 ) THEN
			ixoff = ( mxchr - nchrs ) / 2
		    ELSE
			ixoff = ioffx
		    END IF
		    record = ' '
		    record ( ixoff+1:ixoff+nchrs ) =
     +				string (istrt:itend-1)
		    WRITE (lun, '(A)',IOSTAT=ios)
     +			   record ( 1:ixoff+nchrs )
		    IF ( ios .ne. 0 ) THEN
			iret = -23
			RETURN
		    END IF
		    istrt = itend + 1
		    nclft = lng - istrt + 1
		END DO
	    END IF
	END IF
C*
	RETURN
	END
