	PROGRAM  GDFAZR
C************************************************************************
C* GDFAZR								*
C*									*
C* This program creates fvs file entries for phase errors.		*
C*									*
C**									*
C* Log:									*
C* K. Brill	 4/00							*
C* K. Brill	 6/00	Add ANLSRC & PRMNAM; |region; output changes	*
C* K. Brill	 7/00	Double precision arrays; NSIGWV = wv#/max frac	*
C* K. Brill      8/00	New output record for VSDB			*
C* K. Brill/HPC	 2/05	Changes for new GD & DG libraries		*
C* K. Brill/HPC  3/08   CALL GD_INIT					*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
	PARAMETER	( MAXAB = 750, MXWVS = 8 )
C*
	CHARACTER	gdffor*(LLMXLN), gdatim*(LLMXLN),
     +			gfunf*(LLMXLN),  glevel*(LLMXLN),
     +			gvcord*(LLMXLN), garea*(LLMXLN),
     +			gdfobs*(LLMXLN), deltay*(LLMXLN),
     +			nsigwv*(LLMXLN), output*(LLMXLN),
     +			gfuno*(LLMXLN),  frcstr*(LLMXLN),
     +			anlsrc*(LLMXLN), prmnam*(LLMXLN)
C*
	CHARACTER	filnam*132, vlddtm*20, gdtm*36
	CHARACTER*32	carea (2)
	REAL		anlb (LLNANL)
	REAL		fnav (LLNNAV), onav (LLNNAV)
	REAL		fgrd (LLMXGD), ogrd (LLMXGD)
	DOUBLE
     +	PRECISION	af (MAXAB), bf (MAXAB), ao (MAXAB), bo (MAXAB)
	REAL		degerr (MXWVS), varcnf (MXWVS), varcno (MXWVS)
	REAL		paf (MXWVS), pao (MXWVS), zone (4)
	INTEGER		kmxerr (MXWVS), TG_YYMD
	INTEGER		level (2), luns (4), intdtf (3)
        CHARACTER       parm*12, pfunc*72, devs(4)*1
	CHARACTER	time(2)*20, timtmp*20
	REAL		csig(2)
	LOGICAL		respnd, done, proces, gottm
C*
	INCLUDE		'ERMISS.FNC'
C-----------------------------------------------------------------------
C*	Initialize TAE and GEMPLT.
C*	Note that GEMPLT is only used to translate grid coordinates.
C
	CALL IP_INIT  ( respnd, iperr )
	IF  ( iperr .eq. 0 )  THEN
	    mode = 1
	    CALL GG_INIT  ( mode, iperr )
	END IF
	IF  ( iperr .eq. 0 )  THEN
	    done = .false.
	  ELSE
	    done = .true.
	END IF
	CALL IP_IDNT  ( 'GDFAZR', ier )
	CALL GD_INIT ( ierr )
C
C*	Main loop to read in TAE parameters and list data.
C
	DO WHILE  ( .not. done )
C
C*	  Set flag to indicate processing will be done.
C
	  proces = .true.
C
C*	  Read in the variables from the TAE.
C
	  CALL GDFINP  ( gdffor, frcstr, gdfobs, anlsrc,
     +			 gdatim, glevel, gvcord, gfunf, gfuno,
     +			 prmnam, garea,  deltay, nsigwv, output,
     +			 iperr )
C
C*	  Exit if there is an error
C
	  IF ( frcstr .eq. ' ' ) THEN
	      CALL ER_WMSG ( 'GDFAZR', -13, ' ', ier )
	      proces = .false.
	  END IF
	  IF ( anlsrc .eq. ' ' ) THEN
	      CALL ER_WMSG ( 'GDFAZR', -14, ' ', ier )
	      proces = .false.
	  END IF
	  IF ( prmnam .eq. ' ' ) THEN
	      CALL ER_WMSG ( 'GDFAZR', -15, ' ', ier )
	      proces = .false.
	  END IF
	  IF  ( iperr .ne. 0 )  THEN
	    done = .true.
	  ELSE
C*
	    CALL ST_LCUC ( frcstr, frcstr, ier )
	    CALL ST_LCUC ( anlsrc, anlsrc, ier )
	    CALL ST_LCUC ( prmnam, prmnam, ier )
C
C*	    Get the output units.
C
	    CALL IN_OUTT (output, 'GDFAZR', luns, nlun, devs, iret)
C
C*	    Set number of most significant spectral components:
C
	    CALL ST_RLST ( nsigwv, '/', RMISSD, 2, csig, num, ier )
	    IF ( .not. ERMISS ( csig (1) ) ) THEN
		nwaves = NINT ( csig (1) )
	    ELSE
		nwaves = 1
	    END IF
	    IF ( nwaves .gt. 9 .or. nwaves .lt. 1 ) THEN
		CALL ER_WMSG ( 'GDFAZR', -7, ' ', ierr )
		proces = .false.
	    END IF
C
C*	    Set maximum phase error as fraction of wavelength.
C
	    IF ( .not. ERMISS ( csig (2) ) .and. csig (2) .le. .5
     +		 .and. csig (2) .gt. 0.0 ) THEN
		wfrcmx = csig (2)
	    ELSE
		wfrcmx = .500
	    END IF
C
C*	    Get grid subset area, i.e. area which covers AREA.
C
	    IF  ( proces )  THEN
		CALL ST_CLST ( garea, '|', ' ', 2, carea, nn, ier )
		CALL ST_RLST ( carea (1), ';', -9999., 4, zone, num,
     +				ier )
		proces = .not. ERMISS ( zone (1) )
		proces = .not. ERMISS ( zone (2) )
		proces = .not. ERMISS ( zone (3) )
		proces = .not. ERMISS ( zone (4) )
		i1lon = NINT ( zone (2) )
		i2lon = NINT ( zone (4) )
		i1lat = NINT ( zone (1) )
		i2lat = NINT ( zone (3) )
		IF ( nn .eq. 2 ) THEN
		    CALL ST_LCUC ( carea (2), carea (2), ier )
		ELSE
		    carea (2) = ' '
		END IF
	    END IF
	    IF ( proces ) THEN
C
C*		Set the latitude increment for zonal bands.
C
		CALL ST_NUMB ( deltay, idphi, ier )
		dphi = FLOAT (idphi)
		IF ( ier .ne. 0 .or. dphi .le. 0.0 .or.
     +		     carea (2) .ne. ' ' ) THEN
		    nband = 1
		    dphi = FLOAT ( i2lat - i1lat )
		    idphi = NINT ( dphi )
		ELSE
		    nband = FLOAT ( i2lat - i1lat ) / dphi
		    i2lat = NINT ( FLOAT ( nband ) * dphi +
     +			    FLOAT ( i1lat ) )
		END IF
C
C*		Open the forecast grid file and get the grid navigation.
C
		CALL GD_OPEN (  gdffor, .false., LLNANL, LLNNAV, iacss,
     +				anlb, fnav, mxgrd, iret )
		IF ( iret .ne. 0 ) THEN
		    iret = -16
		    CALL ER_WMSG ( 'GDFAZR', iret, ' ', ier )
		    proces = .false.
		END IF
		IF ( proces ) THEN
		    CALL GD_CLOS ( iacss, ier )
		    CALL DG_INTL ( iret )
C
C*		    Set the grid file and date-time stamp.
C
		    CALL DG_NFIL ( gdffor, ' ', iret )
		    CALL DG_NDTM ( gdatim, iret )
		    IF ( iret .ne. 0 ) THEN
			CALL ER_WMSG ( 'DG', iret, ' ', ier )
			proces = .false.
		    END IF
		    CALL DG_NTIM ( .false., .false., time, gottm,
     +				   iret )
		    IF ( iret .ne. 0 ) THEN
			CALL ER_WMSG ( 'DG', iret, ' ', ier )
			proces = .false.
		    END IF
		    CALL TG_DUAL ( time, gdtm, ier )
		END IF
C
C*		Compute requested grid for forecast.
C
		IF ( proces ) THEN
		    CALL DG_GRID  ( gdtm, glevel, gvcord, gfunf,
     +				    pfunc, fgrd, kxf, kyf, time, 
     +				    level, ivcord, parm, iret )
		    IF  ( iret .ne. 0 )  THEN
		        CALL ER_WMSG ( 'DG',  iret, pfunc, ier )
		        proces = .false.
		    END IF
		END IF
		CALL DG_NEND ( ier )
C
C*	        Compute the valid time from the forecast time.
C
		IF ( proces ) THEN
		    CALL TG_VALD ( time (1), vlddtm, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'TG', ier, time (1), ierr )
			proces = .false.
		    ELSE
			iv = INDEX ( vlddtm, 'V' )
			IF ( iv .ne. 0 ) THEN
			    timtmp = vlddtm (1:iv-1) // 'F00'
			    vlddtm = timtmp
			    CALL TG_CTOI ( vlddtm, intdtf, ier )
			    iymd = TG_YYMD ( intdtf (1) )
			    ihhm = intdtf (2)
			    CALL TG_CTOI ( time(1), intdtf, ier )
			    ifhr = MOD ( intdtf (3), 100000 ) / 100
			ELSE
			    iret = -3
			    CALL ER_WMSG ( 'TG', iret, time(1), ier )
			    proces = .false.
			END IF
		    END IF
		END IF
C
C*	        Open the analysis grid file, getting navigation.
C
		IF  ( proces )  THEN
		    CALL GD_OPEN (  gdfobs, .false., LLNANL, LLNNAV, iacss,
     +				    anlb, onav, mxgrd, iret )
		    IF ( iret .ne. 0 ) THEN
			iret = -17
			CALL ER_WMSG ( 'GDFAZR', iret, ' ', ier )
			proces = .false.
		    END IF
		END IF
		IF ( proces ) THEN
		    CALL GD_CLOS ( iacss, ier )
		    CALL DG_INTL ( iret )
C
C*		    Set the grid file and date-time stamp.
C
		    CALL DG_NFIL ( gdfobs, ' ', iret )
		    CALL DG_NDTM ( vlddtm, iret )
		    IF ( iret .ne. 0 ) THEN
			CALL ER_WMSG ( 'DG', iret, ' ', ier )
			proces = .false.
		    END IF
		    CALL DG_NTIM ( .false., .false., time, gottm,
     +				   iret )
		    IF ( iret .ne. 0 ) THEN
			CALL ER_WMSG ( 'DG', iret, ' ', ier )
			proces = .false.
		    END IF
		    CALL TG_DUAL ( time, gdtm, ier )
C
C*		    Compute requested grid for the analysis.
C
		    IF ( proces ) THEN
		        CALL DG_GRID  ( gdtm, glevel, gvcord, gfuno,
     +				        pfunc, ogrd, kxo, kyo, time, 
     +				        level, ivcord, parm, iret )
		        IF  ( iret .ne. 0 )  THEN
		            CALL ER_WMSG ( 'DG',  iret, pfunc, ier )
		            proces = .false.
		        END IF
		    END IF
		    CALL DG_NEND ( ier )
		END IF
	    END IF
C
C*	    Loop over NBAND zonal bands.
C
	    dspc = .25  !resolution in degrees of ced band grid
	    ibnd = 0
	    DO WHILE ( ibnd .lt. nband .and. proces )
		ibnd = ibnd + 1
C
C*		Compute forecast spectral components:
C
		CALL GDFSPC ( dspc, ibnd, i1lat, i1lon, i2lat, i2lon,
     +			      dphi, MAXAB, fnav, fgrd, fmean, fvar,
     +			      af, bf, lnum, phibnd, iret )
C
C*		Compute analysis spectral components:
C
		IF ( iret .eq. 0 )
     +		CALL GDFSPC ( dspc, ibnd, i1lat, i1lon, i2lat, i2lon,
     +			      dphi, MAXAB, onav, ogrd, omean, ovar,
     +			      ao, bo, lnum, phibnd, iret )
C
C*		Compute errors for NWAVES spectral components.
C
		IF ( iret .eq. 0 ) THEN
		    nwv = nwaves
		    CALL PHASERR ( af, bf, ao, bo, lnum, nwv, degerr,
     +			           kmxerr, varcnf, varcno, paf,
     +				   pao, iret )
		END IF
C
C*		Write out FVS records:
C
		IF ( iret .ne. 0 ) THEN
		    CALL ER_WMSG ( 'GDFAZR', iret, ' ', ier )
		ELSE
		    DO iw = 1, nwv
			delta = RADIUS * COS (phibnd*DTR) * dspc * DTR
			delta = delta / 1000.
			dfrac = degerr (iw) / 360.
			rn = 2 * lnum + 1
			pe = rn * delta * dfrac / FLOAT ( kmxerr(iw) )
			fa = SQRT ( 2. * varcnf (iw) )
			aa = SQRT ( 2. * varcno (iw) )
			ptrn = pao (iw)
			wvlen = rn * delta / FLOAT ( kmxerr(iw) )
			fape = ABS ( pe ) / wvlen
			iwvnm = kmxerr (iw)
			lvl = level (1)
			IF ( fape .le. wfrcmx ) THEN
			    CALL GDFOUT ( luns, nlun, frcstr, anlsrc,
     +				      ifhr, iymd, ihhm, carea (2),
     +				      i1lon, i2lon, phibnd, idphi,
     +				      prmnam, lvl, ivcord,
     +				      iw, pe, fa, aa, ptrn,
     +				      varcnf (iw), fvar,
     +				      varcno (iw), ovar,
     +				      wvlen, iwvnm, ier )
			ELSE
			    WRITE (6,*)
     +			    ' Excessive phase error output REJECTED: '
			    llun = 6
			    CALL GDFOUT ( llun, 1, frcstr, anlsrc,
     +				      ifhr, iymd, ihhm, carea (2),
     +				      i1lon, i2lon, phibnd, idphi,
     +				      prmnam, lvl, ivcord,
     +				      iw, pe, fa, aa, ptrn,
     +				      varcnf (iw), fvar,
     +				      varcno (iw), ovar,
     +				      wvlen, iwvnm, ier )
			END IF
		    END DO
		END IF
	    END DO
C
C*	    Prompt for next listing to be done.
C
	    CALL IP_DYNM  ( done, ier )
	  END IF
	END DO
C
C*	Print general error messages if necessary.
C
	IF  (iperr .ne. 0)  CALL ER_WMSG ( 'GDFAZR', iperr, ' ', ier )
C
C*	Exit from GEMPLT and the TAE.
C
	CALL GENDP  ( 0, iret )
	CALL IP_EXIT  ( iret )
C*
	END
