	PROGRAM TSTMFD
C*
	PARAMETER (IGDIM=40, wvlng=12.)
	REAL	agrd(IGDIM), sgrd(IGDIM), fgrd (IGDIM), ofgrd (IGDIM)
C*
	DO i = 1, IGDIM
	    agrd (i) = rand ()
	    fgrd (i) = agrd (i) + SIN (x) ** 4
	    ofgrd (i) = fgrd (i)
	    sgrd (i) = 1.0
	    x = rand ()
	    IF ( x .lt. .33 ) THEN
		agrd (i) = .01
	    END IF
	END DO
	kxy = IGDIM
	CALL GDLMFD ( kxy, agrd, fgrd, iret )
	PRINT *, 'index      agrd     ofgrd      fgrd '
	DO i = 1, IGDIM
	    print 1000, i, agrd (i), ofgrd (i), fgrd (i)
1000	    FORMAT (I5,3(2X,F8.4))
	END DO
	STOP
	END
C
        SUBROUTINE GDLMFD ( kxy, agrd, fgrd, iret )
C************************************************************************
C* GDLMFD								*
C*									*
C* This subroutine modifies the forecast values so that the frequency	*
C* distribution of the forecast matches that of the analysis.		*
C*									*
C*									*
C* GDLMFD ( KXY, AGRD, FGRD, IRET )					*
C*									*
C* Input parameters:							*
C*	KXY		INTEGER		Number of values in arrays	*
C*	AGRD (*)	REAL		Array of analysis values	*
C*									*
C* Input and Output parameter:						*
C*	FGRD (*)	REAL		Array of forecast values	*
C*					Input:  original values		*
C*					Output:  adjusted values	*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C**									*
C* Log:									*
C* K. Brill/HPC      20130208	Reconstructed from earlier versions	*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
	REAL 		agrd (*), fgrd (*)
C*
	REAL		aos (LLMXGD), fos (LLMXGD)
	LOGICAL		found
C*
C*
	INCLUDE		'ERMISS.FNC'
C------------------------------------------------------------------------
	iret = 0
C
C*	Create order statistics of accumulations:
C
	noa = 0
	nof = 0
	DO ii = 1, kxy
	    IF ( .not. ERMISS ( agrd (ii) ) .and.
     +		 .not. ERMISS ( fgrd (ii) ) ) THEN
		noa = noa + 1
		aos (noa) = agrd (ii)
		nof = nof + 1
		fos (nof) = fgrd (ii)
	    END IF
	END DO
	IF ( noa .eq. 0 ) RETURN
C
C*	Bubble sorting is applied:
C
	DO ii = 1, noa-1
	    DO jj = ii+1, noa
		IF ( aos (ii) .gt. aos (jj) ) THEN
		    save = aos (ii)
		    aos (ii) = aos (jj)
		    aos (jj) = save
		END IF
	    END DO
	END DO
C*
	DO ii = 1, nof-1
	    DO jj = ii+1, nof
		IF ( fos (ii) .gt. fos (jj) ) THEN
		    save = fos (ii)
		    fos (ii) = fos (jj)
		    fos (jj) = save
		END IF
	    END DO
	END DO
C
C*	Do the frequency matching:
C
	icntf = 0
	DO jj = 1, kxy
	    IF ( .not. ERMISS ( fgrd (jj) ) .and.
     +	         .not. ERMISS ( agrd (jj) ) ) THEN
		forval = fgrd (jj)
C
C*		Find the position of this amount in the
C*		forecast order statistics.
C
		found = .false.
		ii = 1
	        sw = 1.0
		DO WHILE ( .not. found .and. ii .lt. nof )
		    swlo = sw
		    found = ( forval .ge. fos (ii) .and.
     +			      forval .lt. fos (ii+1) )
		    IF ( forval .eq. fos (ii) .and.
     +			 fos (ii) .eq. fos (ii+1) .and.
     +			 ii .gt. icntf ) THEN
			icntf = icntf + 1
			found = .true.
		    END IF
		    ii = ii + 1
		    sw = FLOAT (II)
		END DO
C*
		ii = ii - 1
C
C*		Interpolate the quantile value position:
C
		ddif = fos (ii+1) - fos (ii)
		IF ( ddif .gt. 1.0E-05 ) THEN
		    fswt = swlo + ( forval - fos(ii) ) / ddif
		ELSE
		    fswt = swlo
		END IF
		IF ( fswt .gt. sw ) THEN
		    fswt = sw
		END IF
C*
		ii = INT (fswt)
		IF ( ii .ge. noa ) THEN
		    qa = aos (noa)
		ELSE
C
C*		    Interpolate the analysis between ii and ii+1.
C
		    awlo = FLOAT (ii)
		    qa = aos (ii) + ( aos (ii+1) - aos (ii) ) *
     +			     ( fswt - awlo )
		    IF ( qa .gt. aos (noa) ) qa = aos (noa)
		END IF
		fgrd (jj) = qa
	    END IF
	END DO
C*
	RETURN
	END
