	PROGRAM  GDGBS
C************************************************************************
C* GDGBS								*
C*									*
C* This program creates VSDB file entries for the General Brier Score	*
C* (GBS) with a single threshold.					*
C*									*
C**									*
C* Log:									*
C* K. Brill	10/02							*
C* K. Brill/HPC	 	5/05	Make ighdr big				*
C* K. Brill/HPC     20080304	CALL GD_INIT				*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	CHARACTER	gdffor*(LLMXLN), gdatim*(LLMXLN),
     +			regins*(LLMXLN), glevel*(LLMXLN),
     +			gvcord*(LLMXLN), statyp*(LLMXLN),
     +			gdfanl*(LLMXLN), gdoutf*(LLMXLN),
     +			gridid*(LLMXLN), output*(LLMXLN),
     +			afunc*(LLMXLN),  frcstr*(LLMXLN),
     +			anlsrc*(LLMXLN), prmnam*(LLMXLN),
     +			cgarea*(LLMXLN), proj*(LLMXLN), kxky*(LLMXLN),
     +			pfunc*(LLMXLN)
C*
	CHARACTER	gdfun*(LLMXLN+4)
	CHARACTER	vlddtm*20, parm*12
	REAL		fnav (LLNNAV), anav (LLNNAV), onav (LLNNAV)
	REAL		fgrd (LLMXGD), agrd (LLMXGD), tmpg (LLMXGD)
	INTEGER		level (2), luns (4), intdtf (3), ighdr (256)
        CHARACTER       devs(4)*1
	CHARACTER	time(2)*20, timtmp*20
	LOGICAL		respnd, done, proces, same
	INTEGER		TG_YYMD
	DATA		ighdr / 256 * 0 /
C*
	INCLUDE		'ERMISS.FNC'
C-----------------------------------------------------------------------
C*	Initialize user interface and GEMPLT.
C
	CALL IP_INIT  ( respnd, iperr )
	IF  ( iperr .eq. 0 )  THEN
	    mode = 1
	    CALL GG_INIT  ( mode, iperr )
	    IF ( iperr .ne. 0 ) THEN
		ierr = -16
		CALL ER_WMSG ( 'GDGBS', ierr, ' ', ier )
	    END IF
	    CALL GG_SDEV ( 'GN', ierr )
	    IF ( ierr .ne. 0 ) THEN
		ierr = -1
		CALL ER_WMSG ( 'GDGBS', ierr, ' ', ier )
		iperr = ierr
	    END IF
	END IF
	IF  ( iperr .eq. 0 )  THEN
	    done = .false.
	  ELSE
	    done = .true.
	END IF
	CALL IP_IDNT  ( 'GDGBS', ier )
	CALL GD_INIT  ( ierr )
C
C*	Main loop to read in parameters and do verification.
C
	DO WHILE  ( .not. done )
C
C*	    Set flag to indicate processing will be done.
C
	    proces = .true.
C
C*	    Read in the variables from the user interface.
C
	    CALL GDBINP ( gdffor, frcstr, gridid, statyp,
     +			  cgarea, proj, kxky,
     +			  gdfanl, anlsrc, regins,
     +			  gdatim, glevel, gvcord, afunc, pfunc,
     +			  prmnam, gdoutf, output, iperr )
C
C*	    Exit if there is an error
C
	    IF ( gridid .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDGBS', -10, ' ', ier )
		proces = .false.
	    END IF
	    IF ( frcstr .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDGBS', -11, ' ', ier )
		proces = .false.
	    END IF
	    IF ( anlsrc .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDGBS', -12, ' ', ier )
		proces = .false.
	    END IF
	    IF ( prmnam .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDGBS', -13, ' ', ier )
		proces = .false.
	    END IF
	    IF ( afunc .eq. ' ' .or. pfunc .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDGBS', -17, ' ', ier )
		proces = .false.
	    END IF
	    IF  ( iperr .ne. 0 )  THEN
		done = .true.
		proces = .false.
	    END IF
C*
	    IF ( proces ) THEN
C
C*		Get the output units.
C
		CALL IN_OUTT (output, 'GDGBS', luns, nlun, devs, iret)
		IF ( iret .ne. 0 ) THEN
		    CALL ER_WMSG ( 'IN', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
	    IF ( proces ) THEN
C
C*		Set comparison grid navigation.
C
		CALL GDLNVB ( proj, cgarea, kxky, onav, navszo, iret )
		kxo = NINT ( onav (5) )
		kyo = NINT ( onav (6) )
		proces = ( iret .eq. 0 )
	    END IF
	    IF ( proces ) THEN
C
C*		Open the forecast grid file and get the grid and
C*		its navigation.
C
		gdfun = pfunc
		CALL GDLGET ( gdffor, gdatim, glevel, gvcord, gdfun,
     +                        fgrd, kxf, kyf, fnav, navszf, level,
     +			      ivcrd, time, iret )
		IF  ( iret .ne. 0 )  THEN
		    iret = -3
		    CALL ER_WMSG ( 'GDGBS', iret, ' ', ier )
		    proces = .false.
		END IF
C
C*	        Compute the valid time from the forecast time.
C
		IF ( proces ) THEN
		    CALL TG_VALD ( time (1), vlddtm, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'TG', ier, time (1), ierr )
			proces = .false.
		    ELSE
			iv = INDEX ( vlddtm, 'V' )
			IF ( iv .ne. 0 ) THEN
			    timtmp = vlddtm (1:iv-1) // 'F000'
			    vlddtm = timtmp
			    CALL TG_CTOI ( vlddtm, intdtf, ier )
			    iymd = TG_YYMD ( intdtf (1) )
			    ihhm = intdtf (2)
			    CALL TG_CTOI ( time(1), intdtf, ier )
			    ifhr = MOD ( intdtf (3), 100000 ) / 100
			ELSE
			    iret = -3
			    CALL ER_WMSG ( 'TG', iret, time(1), ier )
			    proces = .false.
			END IF
		    END IF
		END IF
	    END IF
C*
	    IF ( proces ) THEN
C
C*		Open the analysis grid file and get the grid and
C*		its navigation.
C
		gdfun = afunc
		CALL GDLGET ( gdfanl, vlddtm, glevel, gvcord, gdfun,
     +                        agrd, kxa, kya, anav, navsza, level,
     +			      ivcrd, time, iret )
		IF  ( iret .ne. 0 )  THEN
		    iret = -4
		    CALL ER_WMSG ( 'GDGBS', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
C
C*	    Check to see if one grid needs smoothing because
C*	    of resolution differences.
C
	    IF ( proces ) THEN
		CALL GDDXDY ( fnav, fdx, fdy,
     +			      dxmax, dxmin, dymax, dymin, iret )
		IF ( iret .ne. 0 .or. fdx .le. 0.0 ) THEN
		    iret = -5
		    CALL ER_WMSG ( 'GDGBS', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
	    IF ( proces ) THEN
		CALL GDDXDY ( anav, adx, ady,
     +			      dxmax, dxmin, dymax, dymin, iret )
		IF ( iret .ne. 0 .or. adx .le. 0.0 ) THEN
		    iret = -6
		    CALL ER_WMSG ( 'GDGBS', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
	    IF ( proces ) THEN
		fovro = fdx / adx
		ifo = NINT ( fovro )
		iff = NINT ( 1. / fovro )
		IF ( ifo .gt. 1 ) THEN
		    WRITE (6,*) ' Removing ', ifo, ' delta-x wave',
     +				' from analysis grid.'
		    CALL GDLFLT ( ifo, agrd, kxa, kya, tmpg, iret )
		    kxy = kxa * kya
		    DO i = 1, kxy
			agrd (i) = tmpg (i)
		    END DO
		ELSE IF ( iff .gt. 1 ) THEN
		    WRITE (6,*) ' Removing ', iff, ' delta-x wave',
     +				' from forecast grid.'
		    CALL GDLFLT ( iff, fgrd, kxf, kyf, tmpg, iret )
		    kxy = kxf * kyf
		    DO i = 1, kxy
			fgrd (i) = tmpg (i)
		    END DO
		ELSE
		    WRITE (6,*)
     +			' Forcast and analysis grid resolutions',
     +			' comparable.'
		END IF
C
C*		If necessary interpolate analysis to the
C*		comparison grid.
C
		CALL GR_CNAV ( anav, onav, navszo, same, iret )
		IF ( .not. same ) THEN
		    CALL GDLINT ( 0, anav, onav, agrd, tmpg, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GDGBS', ier, ' ', ierr )
			proces = .false.
		    ELSE
			WRITE (6,*) ' Analysis interpolated to',
     +				    ' verification grid successfully.'
			kxy = kxo * kyo
			DO i = 1, kxy
			    agrd (i) = tmpg (i)
			END DO
		    END IF
		ELSE
		    WRITE (6,*) ' Analysis and verification are on',
     +				' the same grid.'
		END IF
	    END IF
	    IF ( proces ) THEN
C
C*		If necessary interpolate forecast to the
C*		comparison grid.
C
		CALL GR_CNAV ( fnav, onav, navszo, same, iret )
		IF ( .not. same ) THEN
		    CALL GDLINT ( 0, fnav, onav, fgrd, tmpg, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GDGBS', ier, ' ', ierr )
			proces = .false.
		    ELSE
			WRITE (6,*) ' Forecast interpolated to',
     +				    ' verification grid successfully.'
			kxy = kxo * kyo
			DO i = 1, kxy
			    fgrd (i) = tmpg (i)
			END DO
		    END IF
		ELSE
		    WRITE (6,*) ' Verification and forecast are on',
     +				' the same grid.'
		END IF
	    END IF
	    IF ( proces ) THEN
C
C*		If GDOUTF is specified, open the output grid file
C*		and write A & F grids.
C
		CALL GDLOOF ( gdoutf, onav, igdof, ier )
		IF ( igdof .ne. 0 ) THEN
		    parm = 'A'
		    CALL GD_WDAT ( igdof, agrd, kxo, kyo, ighdr,
     +				   time, level, ivcrd, parm,
     +				   .true., ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GD', ier, ' ', ierr )
		    END IF
		    parm = 'F'
		    CALL GD_WDAT ( igdof, fgrd, kxo, kyo, ighdr,
     +				   time, level, ivcrd, parm,
     +				   .true., ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GD', ier, ' ', ierr )
		    END IF
		END IF
C
C*		Create VSDB records for SL1L2 values on full grid
C*		and regions, if required.
C
		CALL GDBVDB ( gridid, frcstr, anlsrc, prmnam, regins,
     +			      statyp, ifhr, iymd, ihhm, level, ivcrd,
     +			      luns, nlun, agrd, fgrd,
     +			      kxo, kyo, onav, ier )
C*
		IF ( ier .eq. 0 ) THEN
C
C*		    If required, write FA and AA to the output
C*		    grid file.
C
		    IF ( igdof .ne. 0 ) THEN
			parm = 'AA'
			CALL GD_WDAT ( igdof, agrd, kxo, kyo, ighdr,
     +				       time, level, ivcrd, parm,
     +				       .true., ier )
			IF ( ier .ne. 0 ) THEN
			    CALL ER_WMSG ( 'GD', ier, ' ', ierr )
			END IF
			parm = 'FA'
			CALL GD_WDAT ( igdof, fgrd, kxo, kyo, ighdr,
     +				       time, level, ivcrd, parm,
     +				       .true., ier )
			IF ( ier .ne. 0 ) THEN
			    CALL ER_WMSG ( 'GD', ier, ' ', ierr )
			END IF
		    END IF
		END IF
	    END IF
	    IF ( igdof .ne. 0 ) THEN
		CALL GD_CLOS ( igdof, ier )
	    END IF
C
C*	    Prompt for next listing to be done.
C
	    CALL IP_DYNM  ( done, ier )
	END DO
C
C*	Print general error messages if necessary.
C
	IF  (iperr .ne. 0)  CALL ER_WMSG ( 'GDGBS', iperr, ' ', ier )
C
C*	Exit from GEMPLT and the TAE.
C
	CALL GENDP  ( 0, iret )
	CALL IP_EXIT  ( iret )
C*
	END
