	PROGRAM  GDL1L2
C************************************************************************
C* GDL1L2								*
C*									*
C* This program creates VSDB file entries for ML1L2 and S[S]AL1L2 norms.*
C* It also creates VSDB file entries for VL1L2 and V[S]AL1L2 norms.	*
C*									*
C**									*
C* Log:									*
C* K. Brill	 4/01							*
C* K. Brill/HPC	 1/04	Allow ! as a separator between forecast and	*
C*			analysis parameter names in GFUNC		*
C* K. Brill/HPC	 5/05	Make ighdr big					*
C* K. Brill/HPC  6/07	Output ML1L2 instead of SL1L2			*
C* K. Brill/HPC  3/08   CALL GD_INIT					*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	CHARACTER	gdffor*(LLMXLN), gdatim*(LLMXLN),
     +			regins*(LLMXLN), glevel*(LLMXLN),
     +			gvcord*(LLMXLN), gdmnsd*(LLMXLN),
     +			gdfanl*(LLMXLN), gdoutf*(LLMXLN),
     +			gridid*(LLMXLN), output*(LLMXLN),
     +			gfunc*(LLMXLN),  frcstr*(LLMXLN),
     +			anlsrc*(LLMXLN), prmnam*(LLMXLN),
     +			cgarea*(LLMXLN), proj*(LLMXLN), kxky*(LLMXLN),
     +			gvect*(LLMXLN)
C*
	CHARACTER	gdfun*(LLMXLN+4), sttyp*8
	CHARACTER*(LLMXLN+4) cfunc (2)
	CHARACTER	vlddtm*20, parm*12
	REAL		fnav (LLNNAV), anav (LLNNAV), onav (LLNNAV)
	REAL		fgrd (LLMXGD), agrd (LLMXGD), tmpg (LLMXGD)
	REAL		fvgrd (LLMXGD), avgrd (LLMXGD)
	INTEGER		level (2), luns (4), intdtf (3), ighdr (256)
        CHARACTER       devs(4)*1
	CHARACTER	time(2)*20, timtmp*20
	LOGICAL		respnd, done, proces, same, vector, stdz
	INTEGER		TG_YYMD
	DATA		ighdr / 256 * 0 /
C*
	INCLUDE		'ERMISS.FNC'
C-----------------------------------------------------------------------
C*	Initialize user interface and GEMPLT.
C
	CALL IP_INIT  ( respnd, iperr )
	IF  ( iperr .eq. 0 )  THEN
	    mode = 1
	    CALL GG_INIT  ( mode, iperr )
	    IF ( iperr .ne. 0 ) THEN
		ierr = -18
		CALL ER_WMSG ( 'GDL1L2', ierr, ' ', ier )
	    END IF
	    CALL GG_SDEV ( 'GN', ierr )
	    IF ( ierr .ne. 0 ) THEN
		ierr = -1
		CALL ER_WMSG ( 'GDL1L2', ierr, ' ', ier )
		iperr = ierr
	    END IF
	END IF
	IF  ( iperr .eq. 0 )  THEN
	    done = .false.
	  ELSE
	    done = .true.
	END IF
	CALL IP_IDNT  ( 'GDL1L2', ier )
	CALL GD_INIT  ( ierr )
C
C*	Main loop to read in parameters and do verification.
C
	DO WHILE  ( .not. done )
C
C*	    Set flag to indicate processing will be done.
C
	    proces = .true.
C
C*	    Read in the variables from the user interface.
C
	    CALL GDLINP ( gdffor, frcstr, gridid, cgarea, proj, kxky,
     +			gdfanl, anlsrc, regins, gdmnsd,
     +			gdatim, glevel, gvcord, gfunc, gvect,
     +			prmnam, gdoutf, output, iperr )
C
C*	    Exit if there is an error
C
	    IF ( gridid .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDL1L2', -10, ' ', ier )
		proces = .false.
	    END IF
	    IF ( frcstr .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDL1L2', -11, ' ', ier )
		proces = .false.
	    END IF
	    IF ( anlsrc .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDL1L2', -12, ' ', ier )
		proces = .false.
	    END IF
	    IF ( prmnam .eq. ' ' ) THEN
		CALL ER_WMSG ( 'GDL1L2', -13, ' ', ier )
		proces = .false.
	    END IF
	    IF ( gfunc .ne. ' ' .and. gvect .ne. ' ' ) THEN
		CALL ER_WMSG ( 'GDL1L2', -17, ' ', ier )
		proces = .false.
	    ELSE IF ( gfunc .ne. ' ' ) THEN
		vector = .false.
	    ELSE
		vector = .true.
	    END IF
	    IF  ( iperr .ne. 0 )  THEN
		done = .true.
		proces = .false.
	    END IF
C*
	    IF ( proces ) THEN
C
C*		Get the output units.
C
		CALL IN_OUTT (output, 'GDL1L2', luns, nlun, devs, iret)
		IF ( iret .ne. 0 ) THEN
		    CALL ER_WMSG ( 'IN', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
	    IF ( proces ) THEN
C
C*		Set comparison grid navigation.
C
		CALL GDLNVB ( proj, cgarea, kxky, onav, navszo, iret )
		kxo = NINT ( onav (5) )
		kyo = NINT ( onav (6) )
		proces = ( iret .eq. 0 )
	    END IF
	    IF ( proces ) THEN
C
C*		Open the forecast grid file and get the grid and
C*		its navigation.
C
		IF ( vector ) THEN
		    CALL ST_CLST ( gvect, '!', ' ', 2, cfunc, nc, ier )
		    IF ( cfunc (2) .eq. ' ' ) cfunc (2) = cfunc (1)
		    CALL ST_LSTR ( cfunc(1), lnv, ier )
		    gdfun = 'UN(' // cfunc(1) (1:lnv) // ')'
		ELSE
		    CALL ST_CLST ( gfunc, '!', ' ', 2, cfunc, nc, ier )
		    IF ( cfunc (2) .eq. ' ' ) cfunc (2) = cfunc (1)
		    gdfun = cfunc(1)
		END IF
		CALL GDLGET ( gdffor, gdatim, glevel, gvcord, gdfun,
     +                        fgrd, kxf, kyf, fnav, navszf, level,
     +			      ivcrd, time, iret )
		IF ( vector .and. iret .eq. 0 ) THEN
		    gdfun = 'VN(' // cfunc(1) (1:lnv) // ')'
		    CALL GDLGET ( gdffor, gdatim, glevel, gvcord, gdfun,
     +                            fvgrd, kxf, kyf, fnav, navszf, level,
     +			          ivcrd, time, iret )
		END IF
		IF  ( iret .ne. 0 )  THEN
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		    iret = -3
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		    proces = .false.
		END IF
C
C*	        Compute the valid time from the forecast time.
C
		IF ( proces ) THEN
		    CALL TG_VALD ( time (1), vlddtm, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'TG', ier, time (1), ierr )
			proces = .false.
		    ELSE
			iv = INDEX ( vlddtm, 'V' )
			IF ( iv .ne. 0 ) THEN
			    timtmp = vlddtm (1:iv-1) // 'F000'
			    vlddtm = timtmp
			    CALL TG_CTOI ( vlddtm, intdtf, ier )
			    iymd = TG_YYMD ( intdtf (1) )
			    ihhm = intdtf (2)
			    CALL TG_CTOI ( time(1), intdtf, ier )
			    ifhr = MOD ( intdtf (3), 100000 ) / 100
			ELSE
			    iret = -3
			    CALL ER_WMSG ( 'TG', iret, time(1), ier )
			    proces = .false.
			END IF
		    END IF
		END IF
	    END IF
C*
	    IF ( proces ) THEN
C
C*		Open the analysis grid file and get the grid and
C*		its navigation.
C
		IF ( vector ) THEN
		    CALL ST_LSTR ( cfunc(2), lnv, ier )
		    gdfun = 'UN(' // cfunc(2) (1:lnv) // ')'
		ELSE
		    gdfun = cfunc(2)
		END IF
		CALL GDLGET ( gdfanl, vlddtm, glevel, gvcord, gdfun,
     +                        agrd, kxa, kya, anav, navsza, level,
     +			      ivcrd, time, iret )
		IF ( vector .and. iret .eq. 0 ) THEN
		    gdfun = 'VN(' // cfunc(2) (1:lnv) // ')'
		    CALL GDLGET ( gdfanl, vlddtm, glevel, gvcord, gdfun,
     +                            avgrd, kxa, kya, anav, navsza, level,
     +			          ivcrd, time, iret )
		END IF
		IF  ( iret .ne. 0 )  THEN
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		    iret = -4
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
C
C*	    Check to see if one grid needs smoothing because
C*	    of resolution differences.
C
	    IF ( proces ) THEN
		CALL GDDXDY ( fnav, fdx, fdy,
     +			      dxmax, dxmin, dymax, dymin, iret )
		IF ( iret .ne. 0 .or. fdx .le. 0.0 ) THEN
		    iret = -5
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
	    IF ( proces ) THEN
		CALL GDDXDY ( anav, adx, ady,
     +			      dxmax, dxmin, dymax, dymin, iret )
		IF ( iret .ne. 0 .or. adx .le. 0.0 ) THEN
		    iret = -6
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		    proces = .false.
		END IF
	    END IF
	    IF ( proces ) THEN
		fovro = fdx / adx
		ifo = NINT ( fovro )
		iff = NINT ( 1. / fovro )
		IF ( ifo .gt. 1 ) THEN
		    WRITE (6,*) ' Removing ', ifo, ' delta-x wave',
     +				' from analysis grid.'
		    CALL GDLFLT ( ifo, agrd, kxa, kya, tmpg, iret )
		    kxy = kxa * kya
		    DO i = 1, kxy
			agrd (i) = tmpg (i)
		    END DO
		    IF ( vector ) THEN
			CALL GDLFLT ( ifo, avgrd, kxa, kya, tmpg, iret )
			DO i = 1, kxy
			    avgrd (i) = tmpg (i)
			END DO
		    END IF
		ELSE IF ( iff .gt. 1 ) THEN
		    WRITE (6,*) ' Removing ', iff, ' delta-x wave',
     +				' from forecast grid.'
		    CALL GDLFLT ( iff, fgrd, kxf, kyf, tmpg, iret )
		    kxy = kxf * kyf
		    DO i = 1, kxy
			fgrd (i) = tmpg (i)
		    END DO
		    IF ( vector ) THEN
			CALL GDLFLT ( iff, fvgrd, kxf, kyf, tmpg, iret )
			DO i = 1, kxy
			    fvgrd (i) = tmpg (i)
			END DO
		    END IF
		ELSE
		    WRITE (6,*)
     +			' Forcast and analysis grid resolutions',
     +			' comparable.'
		END IF
C
C*		If necessary interpolate analysis to the
C*		comparison grid.
C
		CALL GR_CNAV ( anav, onav, navszo, same, iret )
		IF ( .not. same ) THEN
		    CALL GDLINT ( 0, anav, onav, agrd, tmpg, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GDL1L2', ier, ' ', ierr )
			proces = .false.
		    ELSE
			WRITE (6,*) ' Analysis interpolated to',
     +				    ' verification grid successfully.'
			kxy = kxo * kyo
			DO i = 1, kxy
			    agrd (i) = tmpg (i)
			END DO
		    END IF
		ELSE
		    WRITE (6,*) ' Analysis and verification are on',
     +				' the same grid.'
		END IF
		IF ( .not. same .and. vector ) THEN
		    CALL GDLINT ( 0, anav, onav, avgrd, tmpg, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GDL1L2', ier, ' ', ierr )
			proces = .false.
		    ELSE
			DO i = 1, kxy
			    avgrd (i) = tmpg (i)
			END DO
		    END IF
		ENDIF
	    END IF
	    IF ( proces ) THEN
C
C*		If necessary interpolate forecast to the
C*		comparison grid.
C
		CALL GR_CNAV ( fnav, onav, navszo, same, iret )
		IF ( .not. same ) THEN
		    CALL GDLINT ( 0, fnav, onav, fgrd, tmpg, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GDL1L2', ier, ' ', ierr )
			proces = .false.
		    ELSE
			WRITE (6,*) ' Forecast interpolated to',
     +				    ' verification grid successfully.'
			kxy = kxo * kyo
			DO i = 1, kxy
			    fgrd (i) = tmpg (i)
			END DO
		    END IF
		ELSE
		    WRITE (6,*) ' Verification and forecast are on',
     +				' the same grid.'
		END IF
		IF ( .not. same .and. vector ) THEN
		    CALL GDLINT ( 0, fnav, onav, fvgrd, tmpg, ier )
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GDL1L2', ier, ' ', ierr )
			proces = .false.
		    ELSE
			DO i = 1, kxy
			    fvgrd (i) = tmpg (i)
			END DO
		    END IF
		END IF
	    END IF
	    IF ( proces ) THEN
C
C*		If GDOUTF is specified, open the output grid file
C*		and write A & F grids.
C
		CALL GDLOOF ( gdoutf, onav, igdof, ier )
		IF ( igdof .ne. 0 ) THEN
		    IF ( vector ) THEN
			parm = 'UA'
		    ELSE
			parm = 'A'
		    END IF
		    CALL GD_WDAT ( igdof, agrd, kxo, kyo, ighdr,
     +				   time, level, ivcrd, parm,
     +				   .true., ier )
		    IF ( ier .eq. 0 .and. vector ) THEN
			parm = 'VA'
			CALL GD_WDAT ( igdof, avgrd, kxo, kyo, ighdr,
     +				       time, level, ivcrd, parm,
     +				       .true., ier )
		    END IF
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GD', ier, ' ', ierr )
		    END IF
		    IF ( vector ) THEN
			parm = 'UF'
		    ELSE
			parm = 'F'
		    END IF
		    CALL GD_WDAT ( igdof, fgrd, kxo, kyo, ighdr,
     +				   time, level, ivcrd, parm,
     +				   .true., ier )
		    IF ( ier .eq. 0 .and. vector ) THEN
			parm = 'VF'
			CALL GD_WDAT ( igdof, fvgrd, kxo, kyo, ighdr,
     +				       time, level, ivcrd, parm,
     +				       .true., ier )
		    END IF
		    IF ( ier .ne. 0 ) THEN
			CALL ER_WMSG ( 'GD', ier, ' ', ierr )
		    END IF
		END IF
C
C*		Create VSDB records for ML1L2 values on full grid
C*		and regions, if required.
C
		IF ( vector ) THEN
		    sttyp = 'VL1L2'
		ELSE
		    sttyp = 'ML1L2'
		END IF
		CALL GDLVDB ( gridid, frcstr, anlsrc, prmnam, regins,
     +			      sttyp, ifhr, iymd, ihhm, level, ivcrd,
     +			      luns, nlun, agrd, fgrd, avgrd, fvgrd,
     +			      kxo, kyo, onav, ier )
C
C*		If GDMNSD exists, open it and compute standardized
C*		anomalies.
C
		CALL GDLANO ( vector, gdmnsd, level, ivcrd, onav,
     +			      agrd, fgrd, avgrd, fvgrd, tmpg, stdz,
     +			      iret )
		IF ( iret .lt. 0 ) THEN
		    iret = -19
		    CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		END IF
C*
		IF ( iret .eq. 0 ) THEN
C
C*		    If required, write FA and AA to the output
C*		    grid file.
C
		    IF ( igdof .ne. 0 ) THEN
			IF ( vector ) THEN
			    parm = 'UAA'
			ELSE
			    parm = 'AA'
			END IF
			CALL GD_WDAT ( igdof, agrd, kxo, kyo, ighdr,
     +				       time, level, ivcrd, parm,
     +				       .true., ier )
			IF ( ier .eq. 0 .and. vector ) THEN
			    parm = 'VAA'
			    CALL GD_WDAT ( igdof, avgrd, kxo, kyo,
     +					   ighdr,
     +				           time, level, ivcrd, parm,
     +				           .true., ier )
			END IF
			IF ( ier .ne. 0 ) THEN
			    CALL ER_WMSG ( 'GD', ier, ' ', ierr )
			END IF
			IF ( vector ) THEN
			    parm = 'UFA'
			ELSE
			    parm = 'FA'
			END IF
			CALL GD_WDAT ( igdof, fgrd, kxo, kyo, ighdr,
     +				       time, level, ivcrd, parm,
     +				       .true., ier )
			IF ( ier .eq. 0 .and. vector ) THEN
			    parm = 'VFA'
			    CALL GD_WDAT ( igdof, fvgrd, kxo, kyo,
     +					   ighdr,
     +				           time, level, ivcrd, parm,
     +				           .true., ier )
			END IF
			IF ( ier .ne. 0 ) THEN
			    CALL ER_WMSG ( 'GD', ier, ' ', ierr )
			END IF
		    END IF
C
C*		    Create VSDB records for SAL1L2 values on full grid
C*		    and regions, if required.
C
		    IF ( vector ) THEN
			IF ( stdz ) THEN
			    sttyp = 'VSAL1L2'
			ELSE
			    sttyp = 'VAL1L2'
			END IF
		    ELSE
			IF ( stdz ) THEN
			    sttyp = 'SSAL1L2'
			ELSE
			    sttyp = 'SAL1L2'
			END IF
		    END IF
		    CALL GDLVDB ( gridid, frcstr, anlsrc, prmnam,
     +				  regins, sttyp, ifhr, iymd, ihhm,
     +				  level, ivcrd, luns, nlun, agrd,
     +				  fgrd, avgrd, fvgrd, kxo, kyo, onav,
     +				  ier )
		END IF
	    END IF
	    IF ( igdof .ne. 0 ) THEN
		CALL GD_CLOS ( igdof, ier )
	    END IF
C
C*	    Prompt for next listing to be done.
C
	    CALL IP_DYNM  ( done, ier )
	END DO
C
C*	Print general error messages if necessary.
C
	IF  (iperr .ne. 0)  CALL ER_WMSG ( 'GDL1L2', iperr, ' ', ier )
C
C*	Exit from GEMPLT and the TAE.
C
	CALL GENDP  ( 0, iret )
	CALL IP_EXIT  ( iret )
C*
	END
