	SUBROUTINE GDLDXY  ( rnav, dx, dy, iret )
C************************************************************************
C* GDLDXY								*
C*									*
C* This subroutine computes the X and Y  grid increments for the grid	*
C* defined by the navigation block, RNAV.				*
C*									*
C* If the X and Y increments for the grid are within .001 KM of each	*
C* other, then DX = DY.							*
C*									*
C*  GDLDXY ( RNAV, DX, DY, IRET )					*
C*									*
C* Input parameters:							*
C*	RNAV (*)	REAL		Grid navigation block		*
C*									*
C* Output parameters:							*
C*	DX		REAL		X grid spacing (KM)		*
C*	DY		REAL		Y grid spacing (KM)		*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C*					 -1 = DX, DY not computable	*
C*									*
C**									*
C* Log:									*
C* K. BRILL/HPC		 3/01						*
C* K. Brill/HPC		 4/01	Set the grid navigation.		*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	REAL		rnav (*)
C*
	CHARACTER*4	cprj
	REAL		angs (3)
C*
	INCLUDE		'ERMISS.FNC'
C------------------------------------------------------------------------
	iret = 0
C*
	CALL GR_SNAV ( 16, rnav, ier )
	CALL ST_ITOC ( rnav (2), 1, cprj, ier )
	angs (1) = rnav (11)
	angs (2) = rnav (12)
	angs (3) = rnav (13)
	phi = angs (1)
	kx = NINT ( rnav (5) )
	ky = NINT ( rnav (6) )
C*
	CALL GDLDDS  ( cprj, angs, phi, kx, ky, dx, dy, iret )
C*
	IF ( ERMISS (dx) .or. ERMISS (dy) ) THEN
	    iret = -1
	    RETURN
	END IF
C*
	IF ( ABS ( dx - dy ) .lt. .001 ) dx = dy
C*
	RETURN
	END
