	SUBROUTINE GDLOOF ( gdoutf, fnav, igdof, iret )
C************************************************************************
C* GDLOOF								*
C*									*
C* This routine will create a new GEMPAK grid file, or open an 		*
C* existing file for storing F, A, FA, and AA grids.			*
C*									*
C* If the file cannot be opened for any reason, IGDOF = 0 on return.	*
C*									*
C* Output file will be opened to hold no more than 1000 grids.		*
C*									*
C* GDLOOF ( GDOUTF, FNAV, IGDOF, IRET )					*
C*									*
C* Input parameters:							*
C*	GDOUTF		CHAR*		GEMPAK output grid file		*
C*	FNAV (*)	REAL		Output file navigation block	*
C*									*
C* Output parameters:							*
C*	IGDOF		INTEGER		Output grid file number		*
C*	IRET		INTEGER		Return code			*
C*					   0 = normal			*
C*									*
C**									*
C* Log:									*
C* K. Brill/HPC		 4/01						*
C* K. Brill/HPC		12/04	Changes for new DG/GD, see C==		*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	CHARACTER*(*)	gdoutf
	REAL		fnav (*)
C*
	CHARACTER	newfil*132
	REAL		anlblk (LLNANL), rnavo (LLNNAV),
     +			bnds (4)
	LOGICAL		exist, same
C------------------------------------------------------------------------
	iret  = 0
	igdof = 0
C
C*	Check that the output filename is not blank.
C
	IF  ( gdoutf .eq. ' ' )  THEN
	    RETURN
	END IF
C
C*	Check for the existence of the output file. If it exists, open
C*	it, if not, create it.
C
	CALL FL_INQR ( gdoutf, exist, newfil, ier )
	IF  ( exist )  THEN
	    WRITE ( 6, * ) 'Opening the output GEMPAK grid file--'
C==	    CALL GD_OPNF ( gdoutf, .true., igdof, navsz, rnavo,
C==     +			   ianl, anlblk, ihdsz, maxg, iret )
	    CALL GD_OPEN ( gdoutf, .true., LLNANL, LLNNAV, igdof,
     +			   anlblk, rnavo, maxg, iret )
	    IF  ( iret .ne. 0 )  THEN
		igdof = 0
		CALL ER_WMSG ( 'GD', iret, gdoutf, ier )
		RETURN
	    END IF
	    CALL GR_CNAV ( rnavo, fnav, navsz, same, ier )
	    IF ( .not. same ) THEN
		CALL GD_CLOS ( igdof, ier )
		igdof = 0
		iret = -20
		CALL ER_WMSG ( 'GDL1L2', iret, ' ', ier )
		RETURN
	    END IF
	ELSE
C
C*	    Create a new file by one of the methods below.
C
	    WRITE ( 6, * ) 'Creating the output GEMPAK grid file...'
	    ihd = 10
C
C*	    Build dummy analysis block.
C
	    dn = 1.0
	    dx = .5
	    dy = .5
	    bnds (1) = -90.
	    bnds (2) = -180.
	    bnds (3) = 90.
	    bnds (4) = 180.
	    CALL GR_MBAN ( dn, dx, dy, bnds, bnds, bnds,
     +			   anlblk, ier )
C
C*	    Create the file.
C
	    igszch = NINT ( fnav (5) ) * NINT ( fnav (6) )
	    IF ( igszch .gt. LLMXGD ) THEN
		RETURN
	    END IF
	    maxg = 1000
	    CALL GD_CREF ( gdoutf, LLNNAV, fnav, LLNANL, anlblk,
     +			   ihd, maxg, igdof, ierr )
	    IF  ( ierr .ne. 0 )  THEN
		igdof = 0
		RETURN
	    END IF
	END IF
C*
	WRITE ( 6, * ) 'Output GEMPAK grid file is ready...'
C*
	RETURN
	END
