	SUBROUTINE RDTD_ERR ( i, usrmsg, iret )
C************************************************************************
C* RDTD_ERR								*
C*									*
C* This subroutine writes an RDTD error message.			*
C*									*
C* The USRMSG is not written if it is blank.				*
C*									*
C* RDTD_ERR  ( I, USRMSG, IRET )					*
C*									*
C* Input parameters:							*
C*	I		INTEGER		Value of a return code		*
C*	USRMSG		CHAR*		User reference message		*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/EMC		11/97						*
C* K. Brill/EMC		 6/98	Clearnup; changes for multi temp conds	*
C* K. Brill/EMC		 7/98	-39 error for no master trace pt label	*
C* K. Brill/HPC		 2/00	+02 error for all missing points	*
C* K. Brill/HPC		 6/00	+03, -40->-43 errors for PBS_ stat type *
C* K. Brill/HPC		 7/00	-44, -45 errors for PHSE stat type	*
C* K. Brill/HPC		 8/00	More general wording for -30		*
C* K. Brill/HPC		 7/03	-46 error for invalid bias adjustment	*
C* K. Brill/HPC		 9/03	-47 error for invalid ROC curve from OR *
C* K. Brill/HPC		11/03	-48 & -49 error for invalid thrshld lag	*
C* K. Brill/HPC		12/03	-50 error for invalid time range	*
C* K. Brill/HPC		 3/04	+04 warning for Talagrand trace; -51	*
C*				error for Talagrand rank plot		*
C* K. Brill/HPC		 4/04	+05 warning for invalid # of ensembles	*
C* K. Brill/HPC		 5/04	Change Talagrand to Ranked Histogram	*
C* K. Brill/HPC		 5/05	-53 error of PBS type			*
C* K. Brill/HPC		11/05	Changed -53 error			*
C* K. Brill/HPC		01/06	Added error -54				*
C* K. Brill/HPC	        10/06   Make -22 into +06 warning		*
C* K. Brill/HPC	        12/06   Add error -55 -> -58			*
C* K. Brill/HPC      20070122   Add error -59, -60			*
C* K. Brill/HPC      20080520   Add error -61, -62, 63			*
C* K. Brill/IMSG     20160712   Add CRPS errors 64--67                  *
C************************************************************************
	CHARACTER*(*)	usrmsg
C*
C*------------------------------------------------------------------------
	iret = 0
	IF ( usrmsg .ne. ' ' ) THEN
	    CALL ST_LSTR ( usrmsg, lng, ier )
	    WRITE (6,*) usrmsg (1:lng)
	END IF
	IF ( i .eq. 6 ) WRITE (6,*)
     +		 '+06 = Warning:  Traces have different label types.'
	IF ( i .eq. 5 ) WRITE (6,*)
     +		 '+05 = Warning:  Invalid n in E_L1L2/n stat, 1000 used.'
	IF ( i .eq. 4 ) WRITE (6,*)
     +		 '+04 = Warning:  # of trace pts > 1, all pts combined.'
	IF ( i .eq. 3 ) WRITE (6,*)
     +		 '+03 = Probability file could not be used.'
	IF ( i .eq. 2 ) WRITE (6,*)
     +		 '+02 = ALL TRACE POINTS ARE MISSING'
	IF ( i .eq. 1 ) WRITE (6,*)
     +		 '+01 = too many general label lines'
	IF ( i .eq. 0 ) WRITE (6,*)
     +		 '  0 = normal return'
	IF ( i .eq. -1 ) WRITE (6,*)
     +		  '-01 = invalid header record'
	IF ( i .eq. -2 ) WRITE (6,*)
     +		  '-02 = too few condition records'
	IF ( i .eq. -3 ) WRITE (6,*)
     +		  '-03 = invalid condition record'
	IF ( i .eq. -4 ) WRITE (6,*)
     +		  '-04 = No EOCF record in trace data file'
	IF ( i .eq. -5 ) WRITE (6,*)
     +		  '-05 = too many traces'
	IF ( i .eq. -6 ) WRITE (6,*)
     +		  '-06 = trace plot types differ for this plot'
	IF ( i .eq. -7 ) WRITE (6,*)
     +		  '-07 = ind var cell count disagreement'
	IF ( i .eq. -8 ) WRITE (6,*)
     +		  '-08 = invalid condition type number'
	IF ( i .eq. -9 ) WRITE (6,*)
     +		  '-09 = more than one pair of dep var conditions'
	IF ( i .eq. -10 ) WRITE (6,*)
     +		  '-10 = too many general conditions'
	IF ( i .eq. -12 ) WRITE (6,*)
     +		  '-12 = too many specific trace conditions'
	IF ( i .eq. -13 ) WRITE (6,*)
     +		  '-13 = too many list elements in temporary trace cond'
	IF ( i .eq. -14 ) WRITE (6,*)
     +		  '-14 = invalid data header record'
	IF ( i .eq. -15 ) WRITE (6,*)
     +		  '-15 = invalid data header integer data'
	IF ( i .eq. -16 ) WRITE (6,*)
     +		  '-16 = error in skipping unneeded trace data'
	IF ( i .eq. -17 ) WRITE (6,*)
     +		  '-17 = premature end of trace data file'
	IF ( i .eq. -18 ) WRITE (6,*)
     +		  '-18 = invalid t axis labels for time series'
	IF ( i .eq. -19 ) WRITE (6,*)
     +		  '-19 = time series starting points > 1 year apart'
	IF ( i .eq. -20 ) WRITE (6,*)
     +		  '-20 = time change along a time series < 0'
	IF ( i .eq. -21 ) WRITE (6,*)
     +		  '-21 = time change along a time series > 1 year'
	IF ( i .eq. -23 ) WRITE (6,*)
     +		  '-23 = label type is already c -- cannot convert'
	IF ( i .eq. -24 ) WRITE (6,*)
     +		  '-24 = real to char label conversion error'
	IF ( i .eq. -25 ) WRITE (6,*)
     +		  '-25 = cannot add more discrete x axis labels'
	IF ( i .eq. -26 ) WRITE (6,*)
     +		  '-26 = label not found for relative position'
	IF ( i .eq. -27 ) WRITE (6,*)
     +		  '-27 = invalid label type for sort'
	IF ( i .eq. -28 ) WRITE (6,*)
     +		  '-28 = not all trace data was found'
	IF ( i .eq. -29 ) WRITE (6,*)
     +		  '-29 = cannot compute stats based on FHO values'
	IF ( i .eq. -30 ) WRITE (6,*)
     +		  '-30 = trace data depth field # is not valid'
	IF ( i .eq. -31 ) WRITE (6,*)
     +		  '-31 = too many points in trace to return to user'
	IF ( i .eq. -32 ) WRITE (6,*)
     +		  '-32 = invalid computational code number'
	IF ( i .eq. -33 ) WRITE (6,*)
     +		  '-33 = invalid field header ID number'
	IF ( i .eq. -34 ) WRITE (6,*)
     +		  '-34 = invalid  number of temp conds in RDTD_SDV'
	IF ( i .eq. -35 ) WRITE (6,*)
     +		  '-35 = there are no trace labels'
	IF ( i .eq. -36 ) WRITE (6,*)
     +		  '-36 = insufficient data depth for stats'
	IF ( i .eq. -37 ) WRITE (6,*)
     +		  '-37 = invalid trace number in RDTD_TLB'
	IF ( i .eq. -38 ) WRITE (6,*)
     +		  '-38 = too many fill-in points required.'
	IF ( i .eq. -39 ) WRITE (6,*)
     +		  '-39 = master trace point label not found'
	IF ( i .eq. -40 ) WRITE (6,*)
     +		  '-40 = invalid PBS_ statistic type'
	IF ( i .eq. -41 ) WRITE (6,*)
     +		  '-41 = too many PBS_ probability categories'
	IF ( i .eq. -42 ) WRITE (6,*)
     +		  '-42 = Panofsky-Brier score computation failed'
	IF ( i .eq. -43 ) WRITE (6,*)
     +		  '-43 = Invalid forecast risk category'
	IF ( i .eq. -44 ) WRITE (6,*)
     +		  '-44 = # of trace pnts does not match DTRACE'
	IF ( i .eq. -45 ) WRITE (6,*)
     +		  '-45 = no trace weight values were found'
	IF ( i .eq. -46 ) WRITE (6,*)
     +		  '-46 = bias adjustment not valid for this trace'
	IF ( i .eq. -47 ) WRITE (6,*)
     +		  '-47 = ROC curve from OR could not be computed'
	IF ( i .eq. -48 ) WRITE (6,*)
     +		  '-48 = Invalid threshold lag # for adjusting N'
	IF ( i .eq. -49 ) WRITE (6,*)
     +		  '-49 = Lag adjustment of N not valid for this trace'
	IF ( i .eq. -50 ) WRITE (6,*)
     +		  '-50 = Invalid time range'
	IF ( i .eq. -51 ) WRITE (6,*)
     +		  '-51 = Cannot complete Ranked Histogram analysis plot'
	IF ( i .eq. -52 ) WRITE (6,*)
     +		  '-52 = Cannot complete summary analysis rank plot'
	IF ( i .eq. -53 ) WRITE (6,*)
     +		  '-53 = too many user defined PBS probability values'
	IF ( i .eq. -54 ) WRITE (6,*)
     +		  '-54 = time reversal occurred along the time axis'
	IF ( i .eq. -55 ) WRITE (6,*)
     +		  '-55 = invalid prefix comp code for TRK stats'
	IF ( i .eq. -56 ) WRITE (6,*)
     +		  '-56 = insufficient data for TRK CENPRS comp codes'
	IF ( i .eq. -57 ) WRITE (6,*)
     +		  '-57 = insufficient data for TRK MAXWND comp codes'
	IF ( i .eq. -58 ) WRITE (6,*)
     +		  '-58 = insufficient data for TRK 850VOR comp codes'
        IF ( i .eq. -59 ) WRITE (6,*)
     +             '-59 = The number of trace points in an attribute ',
     +                    'diagram trace must be even.'
	IF ( i .eq. -60 ) WRITE (6,*)
     +             '-60 = Computational code 1360 requires the ',
     +			  'PBS statistic type.'
	IF ( i .eq. -61 ) WRITE (6,*)
     +             '-61 = Data depth is not valid for ',
     +			  'PBS statistic type.'
	IF ( i .eq. -62 ) WRITE (6,*)
     +             '-62 = All points on ROC curve from PBS statistic ',
     +			  'type are missing.'
	IF ( i .eq. -63 ) WRITE (6,*)
     +		   '-63 = Parametric ROC curve from PBS could not be ',
     +                   'computed.'
	IF ( i .eq. -64 ) WRITE (6,*)
     +		  '-64 = Too many CRPS cumulative probabilities.'
	IF ( i .eq. -65 ) WRITE (6,*)
     +		  '-65 = Too many CRPS cumulative probabilities ',
     +            ' in user file.'
	IF ( i .eq. -66 ) WRITE (6,*)
     +		  '-66 = Too few CRPS cumulative probabilities.'
	IF ( i .eq. -67 ) WRITE (6,*)
     +             '-67 = Computational code 2307 requires the ',
     +			  'CRPS statistic type.'
	RETURN
	END
