	SUBROUTINE RDTD_GLB ( mxlns, nlns, genlbl, nchrs, cfld, nfld,
     +			      stat, iret )
C************************************************************************
C* RDTD_GLB								*
C*									*
C* This subroutine returns general label strings for a plot.		*
C*									*
C* There may be no general labels for a plot (NLNS=0).  In that case	*
C* all the label information is specific to the traces and can be	*
C* recalled using RDTD_TLB.  If there is only one trace, there will be	*
C* no general label.							*
C*									*
C* If STAT = NONE, then there are no statistic type identifiers given.	*
C* If STAT is blank, then there are different statistic idendifiers	*
C* for each trace.  In the latter case, get the statistic identifier	*
C* for each trace by calling RDTD_TLB.					*
C*									*
C* RDTD_GLB ( MXLNS, NLNS, GENLBL, NCHRS, CFLD, NFLD, STAT, IRET )	*
C*									*
C* Input parameters:							*
C*	MXLNS		CHAR*		Maximum # of strings in GENLBL	*
C*									*
C* Output parameters:							*
C*	NLNS		INTEGER		Number of strings in GENLBL	*
C*	GENLBL (NLNS)	CHAR*		General label string array	*
C*	NCHRS (NLNS)	INTEGER		# of characters in each string 	*
C*	CFLD (NLNS)	CHAR*5		Header/data field name 		*
C*	NFLD (NLNS) 	INTEGER		Header field number		*
C*	STAT		CHAR*		Statistic type identifier	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					 +1 = too many label lines	*
C**									*
C* Log:									*
C* K. Brill/EMC		11/97						*
C* K. Brill/EMC		 1/98	Get STAT ID from trace conditions 	*
C* K. Brill/HPC		10/02	Assign stat type from ind var condition *
C************************************************************************
	INCLUDE		'rdtd.cmn'
C*
	CHARACTER*(*)	genlbl (*), cfld (*), stat
	INTEGER		nchrs (*), nfld (*)
C*
	CHARACTER*8	tmp
C*------------------------------------------------------------------------
	iret = 0
	stat = ' '
	nlns = 0
C
C*	Get the statistic type.
C
	it = 0
	DO WHILE ( it .lt. ntrace .and. stat .ne. '-' )
	    it = it + 1
	    IF ( it .eq. 1 ) THEN
		stat = statnm (1)
	    ELSE IF ( statnm (it) .ne. stat ) THEN
		stat = '-'
	    END IF
	END DO
	IF ( stat .eq. ' ' .and. stativ .ne. ' ' ) stat = stativ
	IF ( stat .eq. ' ' ) stat = 'NONE'
	IF ( stat .eq. '-' ) stat = ' '
C*
	IF ( ngncnd .le. 0 ) RETURN
C*
	DO i = 1, ngncnd
	    IF ( nlns .ge. mxlns ) THEN
		iret = 1
		RETURN
	    END IF
	    nlns = nlns + 1
	    k = ngcfld (i)
	    nfld (nlns) = k
	    IF ( k .gt. 100 ) THEN
		k = k - 100 + MXHDRS
		IF ( k .le. MXPLBL ) THEN
		    cfld (nlns) = prmlbl (k)
		ELSE
		    CALL ST_INCH ( k, tmp, ier )
		    cfld (nlns) = 'DV_' // tmp
		END IF
	    ELSE
		IF ( k .gt. MXPLBL ) THEN
		    iret = -33
		    RETURN
		ELSE
		    cfld (nlns) = prmlbl (k)
		END IF
	    END IF
	    IF ( ngenls (i) .gt. 1 ) THEN
		genlbl (nlns) = cgcnd1 (i,1)
		DO j = 2, ngenls (i)
		    CALL ST_LSTR ( genlbl (nlns), lng, ier )
		    genlbl (nlns) = genlbl (nlns) (1:lng) // '+' //
     +				 cgcnd1 (i,j)
		END DO
	    ELSE IF ( cgcnd2 (i) .ne. ' ' ) THEN
		genlbl (nlns) = cgcnd1 (i,1)
		CALL ST_LSTR ( genlbl (nlns), lng, ier )
		genlbl (nlns) = genlbl (nlns) (1:lng) // '-' //
     +			     cgcnd2 (i)
	    ELSE
		genlbl (nlns) = cgcnd1 (i,1)
	    END IF
	    CALL ST_LSTR ( genlbl (nlns), nchrs (nlns), ier )
	END DO
C*
	RETURN
	END
