	SUBROUTINE RDTD_R2C ( frmt, iret )
C************************************************************************
C* RDTD_R2C								*
C*									*
C* This subroutine converts real type x labels to character labels.	*
C*									*
C* LBLTYP is changed to c.						*
C*									*
C* RDTD_R2C ( FRMT, IRET )						*
C*									*
C* Input parameters:							*
C*	FRMT		CHAR*		Conversion format		*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					-23 = label type is already c	*
C*					-24 = real to char label error	*
C**									*
C* Log:									*
C* K. Brill/EMC		11/97						*
C************************************************************************
	INCLUDE		'rdtd.cmn'
C*
	CHARACTER*(*)	frmt
C*-----------------------------------------------------------------------
	iret = 0
	IF ( lbltyp .eq. 'c' ) THEN
	    iret = -23
	    RETURN
	END IF
	DO i = 1, ntrace
	    IF ( i .eq. 1 .and. npntrs .gt. 0 ) THEN
		jstop = npntrs
	    ELSE
		jstop = ntrpts (i)
	    END IF
	    DO j = 1, jstop
		IF ( xrlbls (i,j) .lt. -1.E30 ) THEN
		    xclbls (i,j) = ' '
		ELSE
		    WRITE (xclbls (i,j), frmt, IOSTAT=ios)
     +			   xrlbls (i,j)
		    IF ( ios .ne. 0 ) THEN
			iret = -24
			RETURN
		    END IF
		END IF
	    END DO
	END DO
	lbltyp = 'c'
C*
	RETURN
	END
