	SUBROUTINE RDTD_TMP ( luntd, nt, ihdr, iret )
C************************************************************************
C* RDTD_TMP								*
C*									*
C* This subroutine stores a dependent variable condition from a	trace	*
C* data file into the temporary data structure TMPCON.			*
C*									*
C* LUNTD is the unit number to which the trace data file is connected.	*
C*									*
C* RDTD_TMP ( LUNTD, NT, IHDR, IRET )					*
C*									*
C* Input parameters:							*
C*	LUNTD		INTEGER		Unit number of trace data file	*
C*	NT		INTEGER		Trace number			*
C*	IHDR (7)	INTEGER		Header record information	*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					 -2 = too few condition records *
C*					 -3 = invalid condition record	*
C*					 -8 = invalid condition type #	*
C*					 -9 = > 1 pair of dep var conds	*
C*					-13 = too many list elements	*
C**									*
C* Log:									*
C* K. Brill/EMC		11/97						*
C* K. Brill/EMC		12/97	Assign STATNM and/or PARMNM		*
C* K. Brill/EMC		 6/98	Modify for multiple temp conditions	*
C************************************************************************
	INCLUDE		'rdtd.cmn'
C*
	INTEGER		ihdr (7)
C*
	CHARACTER*80	recrd
	CHARACTER*32	carr (5)
C*------------------------------------------------------------------------
	iret = 0
C*
	IF ( nt .eq. 1 ) kgsame = .true.
	kgcfld (nt) = ihdr (2)
	ncn = ihdr (5)
	ntmpls (nt) = ncn
	IF ( ncn .gt. MXDVLS ) THEN
	    iret = -13
	    RETURN
	END IF
	ilst = 0
	ios = 0
	recrd = ' '
	DO WHILE ( ios .eq. 0 .and. recrd (1:4) .ne. ENDHDR .and.
     +		   ilst .lt. ncn )
	    READ ( luntd, '(A)', IOSTAT=ios ) recrd
	    IF ( ios .eq. 0 .and. recrd (1:4) .ne. ENDHDR ) THEN
		ilst = ilst + 1
		CALL ST_CLST ( recrd, ' ', ' ', 5, carr, num, ier )
		IF ( num .ne. 5 ) THEN
		    iret = -3
		    RETURN
		ELSE
C
C*		    Intercept the parm and stat names.
C
		    IF ( statnm (nt) .eq. ' ' .and.
     +			 kgcfld (nt) .eq. 10 ) statnm (nt) = carr (4)
		    IF ( parmnm (nt) .eq. ' ' .and.
     +			 kgcfld (nt) .eq. 12 ) parmnm (nt) = carr (4)
C*
		    CALL ST_NUMB ( carr (1), icntyp, ier )
		    IF ( ier .ne. 0 ) THEN
			iret = -8
			RETURN
		    END IF
		    IF ( icntyp .eq. 0 ) THEN
			kgcnd1 (nt,ilst) = 'ALL'
			kgcnd2 (nt) = ' '
		    ELSE IF ( icntyp .lt. 10 ) THEN
			kgcnd1 (nt,ilst) = carr (2)
			IF ( icntyp .ge. 5 .and. icntyp .le. 8 ) THEN
			    kgcnd2 (nt) = carr (3)
			    IF ( ncn .gt. 1 ) THEN
				iret = -9
				RETURN
			    END IF
			ELSE
			    kgcnd2 (nt) = ' '
			END IF
		    ELSE 
			kgcnd1 (nt,ilst) = carr (4)
			IF ( icntyp .ge. 14 .and. icntyp .le. 17 ) THEN
			    kgcnd2 (nt) = carr (5)
			    IF ( ncn .gt. 1 ) THEN
				iret = -9
				RETURN
			    END IF
			ELSE
			    kgcnd2 (nt) = ' '
			END IF
		    END IF
		END IF
	    ELSE
		iret = -2
		RETURN
	    END IF
	END DO
	kgctyp (nt) = icntyp
	ntmpcn = ntmpcn + 1
	IF ( ntmpcn .gt. 1 ) CALL RDTD_CDC ( iret )
C*
	RETURN
	END
