	SUBROUTINE RDTD_VAL ( nmem, cstat, lblt, prbs, nprb, iret )
C************************************************************************
C* RDTD_VAL								*
C*									*
C* This subroutine returns information from the RDTD common block for	*
C* use in the resampling RSMP library.					*
C*									*
C* NOTE:  All traces are assumed to have the same calibration.          *
C*									*
C* RDTD_VAL ( NMEM, CSTAT, LBLT, PRBS, NPRB, IRET )		        *
C*									*
C* Output parameters:							*
C*	NMEM		INTEGER		Number of ensemble members	*
C*	CSTAT		CHAR*		Statistic type name		*
C*	LBLT		CHAR*1		Label type			*
C*	PRBS		REAL		Probability calibrations	*
C*	NPRB		INTEGER		Number of prob categories	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/HPC      20120327   Created					*
C* K. Brill/IMSG     20160707   Documentation updated                   *
C************************************************************************
	INCLUDE		'rdtd.cmn'
C*
	REAL		prbs (MXPROB,MXTRCS)
	INTEGER		nprb (MXTRCS)
C*
	CHARACTER*(*)	cstat, lblt
C*------------------------------------------------------------------------
	iret = 0
C*
	nmem = nembrs
	cstat = cstatc
	lblt = lbltyp
C*
	DO it = 1, MXTRCS
	    nprb (it) = npbwwx (it)
	    DO ip = 1, MXPROB
		prbs (ip,it) = prbwwx (ip,it)
	    END DO
	END DO
C*
	RETURN
	END
