	SUBROUTINE RDTD_VL2 ( prbs, nprb, iret )
C************************************************************************
C* RDTD_VL2								*
C*									*
C* This subroutine returns CRPS calibration information from the RDTD   *
C* common block for use in the resampling RSMP library.			*
C*									*
C* NOTE:  All traces are assumed to have the same calibration.          *
C*									*
C* RDTD_VL2 ( prbs, nprb, IRET )			                *
C*									*
C* Output parameters:							*
C*	PRBS		REAL		Probability calibrations	*
C*	NPRB		INTEGER		Number of prob categories	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/IMSG     20160707   Created					*
C************************************************************************
	INCLUDE		'rdtd.cmn'
C*
	REAL		prbs (MXNCRP,MXTRCS)
	INTEGER		nprb (MXTRCS)
C*
C*------------------------------------------------------------------------
	iret = 0
C*
	DO it = 1, MXTRCS
	    nprb (it) = ncrpsp (it)
	    DO ip = 1, MXNCRP
		prbs (ip,it) = crpspl (ip,it)
	    END DO
	END DO
C*
	RETURN
	END
