	PROGRAM MAKRGN
C************************************************************************
C* MAKRGN								*
C*									*
C* This program uses the GEMPAK grid navigation table file to make an	*
C* entry to a region table file.					*
C*									*
C**									*
C* Log:									*
C* K. Brill/EMC		 7/97						*
C************************************************************************
	CHARACTER*80	filnam
	CHARACTER*8	name
	CHARACTER*4	namgd, projgd
	REAL		anggd (3), gargd (4)
C------------------------------------------------------------------------
	iret  = 0
	lunout = 99
C
C*	Open the navigation table file.
C
	CALL FL_TBOP ( 'grdnav.tbl', 'grid', luntbl, ier )
	IF ( ier .ne. 0 ) THEN
	    WRITE (6,*) ' Cannot open grdnav.tbl file.'
	    STOP
	END IF
	CALL FL_TDAT ( luntbl, ier )
	IF ( ier .ne. 0 ) THEN
	    WRITE (6,*) ' Cannot read past comments of grdnav.tbl.'
	    STOP
	END IF
C
C*	Get user input.
C
	WRITE (6,*) ' Enter output file name:'
	READ (5,'(A)') filnam
	CALL VSDB_OPN ( lunout, filnam, 'a', ier )
	IF ( ier .ne. 0 ) THEN
	    WRITE (6,*) ' Cannot open the output file.'
	    STOP
	END IF
C*
	WRITE (6,*) ' Enter grid number, number of subsets in x, ',
     +		    'and number of subsets in y, separated by blanks.'
	WRITE (6,*) ' '
	WRITE (6,*) ' Enter a negative grid number if you want to',
     +		    ' enter subgrid coordinates (e.g., as in RUC)'
	READ (5,*) ig, nxsub, nysub
C
C*	Find the grid in the navigation table file.
C
	numgd = 0
	ier = 0
	DO WHILE ( ig .ne. numgd .and. ier .eq. 0 .and. ig .gt. 0 )
	    CALL TB_GRNV ( luntbl, namgd, numgd, projgd, anggd, gargd,
     +			   nxgd, nygd, deln, extnd, ier )
	END DO
	IF ( ig .lt. 0 ) THEN
	    WRITE (6,*) ' Enter subgrid index coordinates ',
     +			'(i1,j1,i2,j2) separated by spaces.'
	    READ (5,*) i1,j1,i2,j2
	    ig = IABS (ig)
	    numgd = ig
	    istrt = i1
	    jstrt = j1
	    ifini = i2
	    jfini = j2
	ELSE
	    istrt = 1
	    jstrt = 1
	    ifini = nxgd
	    jfini = nygd
	END IF
	ialpha = ICHAR ( 'A' )
	CALL ST_INCH ( numgd, namgd, ier )
	IF ( numgd .eq. ig ) THEN
	    iinc = ( ifini - istrt ) / nxsub
	    iaddx = MOD ( (ifini-istrt), nxsub )
	    jinc = ( jfini - jstrt ) / nysub
	    jaddy = MOD ( (jfini-jstrt), nysub )
	    nsub = 0
	    jend = jfini
	    jadd = jaddy
	    DO j = nysub, 1, -1
		IF ( jadd .gt. 0 ) THEN
		    jad = 1
		    jadd = jadd - 1
		ELSE
		    jad = 0
		END IF
		jbeg = jend - jinc - jad
		ibeg = istrt
		iadd = iaddx
		DO i = 1, nxsub
		    IF ( iadd .gt. 0 ) THEN
			iad = 1
			iadd = iadd - 1
		    ELSE
			iad = 0
		    END IF
		    iend = ibeg + iinc + iad
C
C*		    Write out the entry for this subset.
C
		    CALL ST_LSTR ( namgd, lnn, ier )
		    name = 'G' // namgd(1:lnn) // CHAR ( ialpha )
		    WRITE ( lunout, 1000 ) name, numgd, ibeg, jbeg,
     +					   iend, jend
1000		    FORMAT ( X, A8, X, 5 ( I6, X ), ' | ' )
		    ibeg = iend
		    ialpha = ialpha + 1
		END DO
		jend = jbeg
	    END DO
	ELSE
	    WRITE (6,*) ' Grid ', ig, ' was not found. '
	END IF
C*
	STOP
	END
