	SUBROUTINE RSMP_ERR ( i, usrmsg, iret )
C************************************************************************
C* RSMP_ERR								*
C*									*
C* This subroutine writes an RSMP error message.			*
C*									*
C* The USRMSG is not written if it is blank.				*
C*									*
C* RSMP_ERR  ( I, USRMSG, IRET )					*
C*									*
C* Input parameters:							*
C*	I		INTEGER		Value of a return code		*
C*	USRMSG		CHAR*		User reference message		*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/HPC      20120322	Created					*
C* K. Brill/HPC      20120413   Add calculator errors			*
C* K. Brill/HPC      20120912   Add -14 error; +02 warning message	*
C************************************************************************
	CHARACTER*(*)	usrmsg
C*
C*------------------------------------------------------------------------
	iret = 0
	IF ( usrmsg .ne. ' ' ) THEN
	    CALL ST_LSTR ( usrmsg, lng, ier )
	    WRITE (6,*) usrmsg (1:lng)
	END IF
C*
	IF ( i .eq. 2 ) WRITE (6,*)
     +		'+02 = WARNING:  No values for resampling at a point.'
	IF ( i .eq. -1 ) WRITE (6,*)
     +		'-01 = Cannot open trace.ucd file for resampling.'
	IF ( i .eq. -2 ) WRITE (6,*)
     +		'-02 = Cannot read data depth from trace.ucd file.'
	IF ( i .eq. -3 ) WRITE (6,*)
     +		'-03 = Too many uncombined VSDB records at a point.'
	IF ( i .eq. -4 ) WRITE (6,*)
     +		'-04 = Trace VSDB record counts differ at a point.'
	IF ( i .eq. -5 ) WRITE (6,*)
     +		'-05 = Bias adjustment requires FHO records.'
	IF ( i .eq. -6 ) WRITE (6,*)
     +		'-06 = Context does not allow box-whisker objects.'
	IF ( i .eq. -7 ) WRITE (6,*)
     +		'-07 = The computational code is invalid.'
	IF ( i .eq. -8 ) WRITE (6,*)
     +		'-08 = The sample is too large for RSMP_TRC.'
	IF ( i .eq. -9 ) WRITE (6,*)
     +		'-09 = Performance metric computation failed.'
	IF ( i .eq. -10 ) WRITE (6,*)
     +		'-10 = Invalid VSDB record data field requested.'
	IF ( i .eq. -11 ) WRITE (6,*)
     +		'-11 = All values are missing in the sorting.'
	IF ( i .eq. -12 ) WRITE (6,*)
     +		'-12 = Data depth is to small.'
	IF ( i .eq. -13 ) WRITE (6,*)
     +		'-13 = Track data computation error.'
	IF ( i .eq. -14 ) WRITE (6,*)
     +		'-14 = Metric calculation error in resampling.'
C*
	RETURN
	END
