	SUBROUTINE SRCH_DMP ( iret )
C************************************************************************
C* SRCH_DMP								*
C*									*
C* This subroutine dumps the SRCH.CMN data structure contents.		*
C*									*
C* SRCH_DMP ( IRET )							*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/EMC		 8/97						*
C* K. Brill/EMC		 4/98	Changes for CHKLST for each trace	*
C* K. Brill/EMC		01/00	FORMAT X to 1X for Linux		*
C* K. Brill/IMSG        04/17   Use D format for reldat                 *
C************************************************************************
	INCLUDE		'srch.cmn'
C*
	LOGICAL		more, cntn
C*------------------------------------------------------------------------
	iret = 0
	more = .true.
	DO WHILE ( more )
	    WRITE (6,*) ' Select common area to dump: '
	    WRITE (6,*) ' '
	    WRITE (6,*) '   1 - INDVAR   2 - DEPVAR   3 - TRCDAT '
	    WRITE (6,*) '   4 - RECDAT   5 - RUFCHX'
	    WRITE (6,*) ' '
	    WRITE (6,*) ' Enter selection or any other number to stop:'
	    READ (5,*) icmn
	    IF ( icmn .eq. 1 ) THEN
		WRITE (6,*) ' There are ', ntrace, ' traces defined.'
		DO it = 1, ntrace
		    WRITE (6,*) ' For trace # ', it, ' there are ',
     +			kivnpt (it), ' conditionally determined',
     +			' independent variable points.'
		    WRITE (6,*) ' There are ', kivncn (it),
     +			' independent variable conditions.'
		    DO ic = 1, kivncn (it)
			WRITE (6,*) ' This condition applies to ',
     +			    'field # ', kivfld (it,ic)
			WRITE (6,1001)
1001			FORMAT ( ' PT ', 9X, 'CHAR 1', 19X, 'CHAR 2',
     +				 12X, 'REAL 1', 5X, 'REAL 2', 3X,
     +				 'CODE' )
1002			FORMAT (1X,I2,1X,A,1X,A,1X,F10.5,1X,F10.5,1X,
     +				 I3 )
			DO ip = 1, kivnpt (it)
			    WRITE (6,1002) ip,
     +				civcnd (it,ic,ip,1)(1:24),
     +				civcnd (it,ic,ip,2)(1:24),
     +				rivcnd (it,ic,ip,1),
     +				rivcnd (it,ic,ip,2), kivcod (it,ic,ip)
			END DO
		    END DO
		END DO
	    ELSE IF ( icmn .eq. 2 ) THEN
		WRITE (6,*) ' There are ', ntrace, ' traces defined.'
		DO it = 1, ntrace
		    WRITE (6,*) ' There are ', kdvncn (it),
     +			' dependent variable conditions.'
		    WRITE (6,*) ' The data combination code is ',
     +			kdvcmb (it)
		    DO ic = 1, kdvncn (it)
			WRITE (6,*) ' This condition applies to ',
     +			    'field # ', kdvfld (it,ic)
			WRITE (6,*) ' The condition code is ',
     +			    kdvcod (it,ic)
			WRITE (6,*) ' Number of listed values = ',
     +				kdvnls (it,ic)
			WRITE (6,1003)
1003			FORMAT ( '  # ', 10X, 'CHAR', 14X, 'REAL' )
			DO ip = 1, kdvnls (it,ic)
			    WRITE (6,1004) ip, cdvcnd (it,ic,ip)(1:24),
     +				rdvcnd (it,ic,ip)
1004			    FORMAT (1X,I2,1X,A,1X,F10.5)
			END DO
		    END DO
		END DO
	    ELSE IF ( icmn .eq. 3 .and. ntrace .ne. 0 ) THEN
		WRITE (6,*) ' There are ', ntrace, ' traces defined.'
		WRITE (6,*) 'Enter the trace number: '
		READ (5,*) mtrc
		WRITE (6,*) '# of points along trace = ', ndatap (mtrc)
		WRITE (6,*) 'Trace data depth = ', ndepth (mtrc)
		DO i = 1, ndepth (mtrc)
		    WRITE (6,*) ' Data record index for value ',
     +				i, ' = ', kindex (mtrc,i)
		END DO
		cntn = .true.
		DO WHILE ( cntn )
		    WRITE (6,*) ' Enter index of trace data to ',
     +				'examine (1 -> ', ndatap (mtrc),
     +				', 0 to stop)'
		    READ (5,*) indx
		    IF ( indx .gt. 0 .and. indx .le. ndatap (mtrc) )
     +		    THEN
			WRITE (6,*) ' Enter data depth index:'
			READ (5,*) idp
			WRITE (6,1122) mtrc, idp, indx,
     +			    dtrace (mtrc,idp,indx),
     +			    mtrc, indx, kounts (mtrc,indx),
     +			    mtrc, indx, rtrcid (mtrc,indx),
     +			    mtrc, indx, ctrcid (mtrc,indx)
1122			FORMAT (' DTRACE (', I4, ',', I4, ',', I4,
     +				') = ', 1PE13.5, 5X,
     +				' KOUNTS (', I4, ',', I4, ') = ',
     +				I13, /,
     +				' RTRCID (', I4, ',', I4, ') = ',
     +				1PE13.5, 5X,
     +				' CTRCID (', I4, ',', I4, ') = ', A )
		    ELSE
			cntn = .false.
		    END IF
		END DO
	    ELSE IF ( icmn .eq. 3 .and. ntrace .eq. 0 ) THEN
		WRITE (6,*) ' No traces have been defined.'
	    ELSE IF ( icmn .eq. 4 ) THEN
		WRITE (6,*) ' Here is the desc. field map:'
		DO i = 1, MXDFDS
		    WRITE (6,*) 'IFDMAP (', i, ') = ', ifdmap (i)
		END DO
		WRITE (6,*) ' Last record = '
		WRITE (6,*) record
		WRITE (6,*) ' Version # = ', ivrson
		WRITE (6,*) ' LUNOUT = ', lunout
		WRITE (6,*) ' Number of fields = ', numfld
		DO i = 1, numfld
		    WRITE (6,*) 'Field # ', i, ' = ', hfield (i)
		END DO
		WRITE (6,*) ' Data part of record = '
		WRITE (6,*) crdata
		WRITE (6,*) 'Number of real values = ', numrel
		DO i = 1, numrel
		    WRITE (6,2323) i, reldat (i)
2323		    FORMAT ( ' Real value # ', I4, ' = ',
     +			     1PD13.5 )
		END DO
	    ELSE IF ( icmn .eq. 5 ) THEN
		DO it = 1, ntrace
		    IF ( nchckx (it) .gt. 0 ) THEN
			WRITE (6,*) ' Number of rough check strings = ',
     +					nchckx (it)
			WRITE (6,*) ' Parity number for checks = ',
     +					ickpar (it)
			WRITE (6,*) ' '
			WRITE (6,*) '  #    HDR FLD #    STRING'
			DO i = 1, nchckx (it)
			    WRITE (6,3434) i, ifdlst (it,i),
     +					   chklst (it,i)(1:24)
3434			    FORMAT (1X,I3,6X,I3,4X,A)
			END DO
		    ELSE
			WRITE (6,*)
     +			  ' No rough check strings for trace # ', it
		    END IF
		END DO
	    ELSE
		more = .false.
	    END IF
	END DO
C*
	RETURN
	END
