	SUBROUTINE SRCH_ERR ( i, usrmsg, iret )
C************************************************************************
C* SRCH_ERR								*
C*									*
C* This subroutine writes a Verification Statistic Database (VSDB)	*
C* search software error message.					*
C*									*
C* The USRMSG is not printed if it is blank.				*
C*									*
C* SRCH_ERR  ( I, USRMSG, IRET )					*
C*									*
C* Input parameters:							*
C*	I		INTEGER		Value of a return code		*
C*	USRMSG		CHAR*		User reference message		*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/EMC		 7/97						*
C* K. Brill/EMC		11/97	Changes for post-search data combination*
C* K. Brill/EMC		 7/98	Added -52 error				*
C* K. Brill/HPC		12/03	Change -35 error msg; add +3 warning	*
C* K. Brill/IMSG     20160107   Add second -36 error message output     *
C************************************************************************
	CHARACTER*(*)	usrmsg
C*
C*-----------------------------------------------------------------------
	iret = 0
	IF ( usrmsg .ne. ' ' ) THEN
	    CALL ST_LSTR ( usrmsg, lng, ier )
	    WRITE (6,*) usrmsg (1:lng)
	END IF
	IF ( i .eq. 3 ) WRITE (6,*)
     +		 '+03 = Warning:  indep var cndtns differ--',
     +		 'labels based on first trace'
	IF ( i .eq. 2 ) WRITE (6,*)
     +		 '+02 = Warning:  a trace has zero points'
	IF ( i .eq. 1 ) WRITE (6,*)
     +		 '+01 = Warning:  data counts differ -- allowed'
	IF ( i .eq. 0 ) WRITE (6,*)
     +		 '  0 = normal return'
	IF ( i .eq. -1 ) WRITE (6,*)
     +		  '-01 = invalid header field number'
	IF ( i .eq. -2 ) WRITE (6,*)
     +		  '-02 = invalid variable type'
	IF ( i .eq. -3 ) WRITE (6,*)
     +		  '-03 = invalid data combining instruction code'
	IF ( i .eq. -4 ) WRITE (6,*)
     +		  '-04 = invalid condition comparison code'
	IF ( i .eq. -5 ) WRITE (6,*)
     +		  '-05 = string list is not expected'
	IF ( i .eq. -6 ) WRITE (6,*)
     +		  '-06 = real value list is not expected'
	IF ( i .eq. -7 ) WRITE (6,*)
     +		  '-07 = cndtn yields different # of pts for indep var'
	IF ( i .eq. -8 ) WRITE (6,*)
     +		  '-08 = VSDB record could not be parsed'
	IF ( i .eq. -9 ) WRITE (6,*)
     +		  '-09 = too many items in a search list'
	IF ( i .eq. -10 ) WRITE (6,*)
     +		   '-10 = number of traces is too large'
	IF ( i .eq. -11 ) WRITE (6,*)
     +		   '-11 = too many dependent variable conditions'
	IF ( i .eq. -12 ) WRITE (6,*)
     +		   '-12 = too many independent variable conditions'
	IF ( i .eq. -13 ) WRITE (6,*)
     +		   '-13 = too many conditionally determined ',
     +		   	 'independent variable points'
	IF ( i .eq. -14 ) WRITE (6,*)
     +		   '-14 = VSDB file could not be opened'
	IF ( i .eq. -15 ) WRITE (6,*)
     +		   '-15 = no traces have been requested'
	IF ( i .eq. -16 ) WRITE (6,*)
     +		   '-16 = parsing error for VSDB record'
	IF ( i .eq. -17 ) WRITE (6,*)
     +		   '-17 = combination type does not agree with that',
     +			  ' already set for trace'
	IF ( i .eq. -18 ) WRITE (6,*)
     +		   '-18 = real check condition is invalid'
	IF ( i .eq. -19 ) WRITE (6,*)
     +		   '-19 = character check condition is invalid'
	IF ( i .eq. -20 ) WRITE (6,*)
     +		   '-20 = number of field to check is beyond data'
	IF ( i .eq. -21 ) WRITE (6,*)
     +		   '-21 = number of field to check is invalid'
	IF ( i .eq. -22 ) WRITE (6,*)
     +		   '-22 = too many points in the trace'
	IF ( i .eq. -23 ) WRITE (6,*)
     +		   '-23 = serial trace CHAR label already exists'
	IF ( i .eq. -24 ) WRITE (6,*)
     +		   '-24 = serial trace REAL label already exists'
	IF ( i .eq. -25 ) WRITE (6,*)
     +		   '-25 = NO CHAR or REAL label exists'
	IF ( i .eq. -26 ) WRITE (6,*)
     +		   '-26 = cannot open the output file'
	IF ( i .eq. -27 ) WRITE (6,*)
     +		   '-27 = output unit number is invalid'
	IF ( i .eq. -28 ) WRITE (6,*)
     +		   '-28 = MKNDX array in SRCH_GET is too small'
	IF ( i .eq. -29 ) WRITE (6,*)
     +		   '-29 = trace number is invalid'
	IF ( i .eq. -30 ) WRITE (6,*)
     +		   '-30 = MXPTS is too small in SRCH_GET'
	IF ( i .eq. -31 ) WRITE (6,*)
     +		   '-31 = index in MSRTI is out of range in SRCH_GET'
	IF ( i .eq. -32 ) WRITE (6,*)
     +		   '-32 = search label values are invalid'
	IF ( i .eq. -33 ) WRITE (6,*)
     +		   '-33 = time period check is invalid'
	IF ( i .eq. -34 ) WRITE (6,*)
     +		   '-34 = plot ID number must be a positive integer'
	IF ( i .eq. -35 ) WRITE (6,*)
     +		   '-35 = traces with same plot ID # have different',
     +			  ' # of indep var conditions'
	IF ( i .eq. -36 ) WRITE (6,*)
     +		   '-36 = trace pnts not combined because of errors'
	IF ( i .eq. -36 ) WRITE (6,*)
     +		   '-36 = Check trace.ctl conditions; check VSDB files'
	IF ( i .eq. -37 ) WRITE (6,*)
     +		   '-37 = cannot store required values---increase ',
     +			  'MXDPTH'
	IF ( i .eq. -38 ) WRITE (6,*)
     +		   '-38 = no values defined by conditions---increase ',
     +			  'MXDPTH'
	IF ( i .eq. -39 ) WRITE (6,*)
     +		   '-39 = all combined traces have 0 pts in SRCH_DMS'
	IF ( i .eq. -40 ) WRITE (6,*)
     +		   '-40 = all combined traces have 0 pts in SRCH_CMC'
	IF ( i .eq. -41 ) WRITE (6,*)
     +		   '-41 = all combined traces have 0 pts in SRCH_CMS'
	IF ( i .eq. -42 ) WRITE (6,*)
     +		   '-42 = all combined traces have 0 pts in SRCH_CSC'
	IF ( i .eq. -43 ) WRITE (6,*)
     +		   '-43 = all combined traces have 0 pts in SRCH_DMC'
	IF ( i .eq. -44 ) WRITE (6,*)
     +		   '-44 = invalid data consistency check code'
	IF ( i .eq. -45 ) WRITE (6,*)
     +		   '-45 = all combined traces have 0 pts in SRCH_DSC'
	IF ( i .eq. -46 ) WRITE (6,*)
     +		   '-46 = requested trace to get has zero points'
	IF ( i .eq. -47 ) WRITE (6,*)
     +		   '-47 = too many elements--cannot pad zeroes'
	IF ( i .eq. -48 ) WRITE (6,*)
     +		   '-48 = cannot mix time and non-time series traces',
     +		   ' on one plot'
	IF ( i .eq. -49 ) WRITE (6,*)
     +		   '-49 = most frequent count not realized as expected'
	IF ( i .eq. -50 ) WRITE (6,*)
     +		   '-50 = combined trace has ZERO points in SRCH_NCC'
	IF ( i .eq. -51 ) WRITE (6,*)
     +		   '-51 = all combined traces have 0 pts in SRCH_TM2'
	IF ( i .eq. -52 ) WRITE (6,*)
     +		   '-52 = duplicate trace labels found'
	RETURN
	END
