	SUBROUTINE SRCH_RUF ( skip, iret )
C************************************************************************
C* SRCH_RUF								*
C*									*
C* This subroutine performs a rough check of the unparsed input data	*
C* record to see if it is a candidate for further checking.  If any	*
C* fixed character matches are found, VSDB_FLD is called and another	*
C* round of rough checking is done.  If matches are found again, then	*
C* SKIP is set to .FALSE., the output from VSDB_FLD is in COMMON.	*
C*									*
C* The record is in a COMMON string called RECORD.			*
C*									*
C* If SKIP is .TRUE., then it is definitely OK to skip this record.	*
C*									*
C* SRCH_RUF ( SKIP, IRET )						*
C*									*
C* Output parameters:							*
C*	SKIP		LOGICAL		Flag to skip this record	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					 -8 = unparseable record	*
C**									*
C* Log:									*
C* K. Brill/EMC		 7/97						*
C* K. Brill/EMC		 4/98	Changes for CHKLST for each trace	*
C************************************************************************
	INCLUDE		'srch.cmn'
C*
	LOGICAL		skip
C*
	LOGICAL		found
C*------------------------------------------------------------------------
	iret = 0
	skip = .false.
C
C*	Search for "check list" elements.
C
	ilst = 0
	found = .false.
	it = 0
	DO WHILE ( .not. found .and. it .lt. ntrace )
	    it = it + 1
	    il = 0
	    icnt = 0
	    DO WHILE ( il .lt. nchckx (it) .and. icnt .lt. ickpar (it) )
		ilst = ilst + 1
		il = il + 1
		iq = INDEX ( record, chklst (it,il) (1:lngthl(it,il)) )
		IF ( iq .ne. 0 ) icnt = icnt + 1
	    END DO
	    IF ( ickpar (it) .eq. icnt ) found = .true.
	END DO
C
C*	Check for having found something in the record.
C
	skip = ( .not. found .and. ilst .gt. 0 )
	IF ( skip ) RETURN
C
C*	Call VSDB_FLD to get the descriptor and data fields.
C*	These are read into COMMON.
C
	numfld = MXFLDS
	CALL VSDB_FLD ( record, numfld, hfield, ivrson, crdata, ier )
	IF ( ier .ne. 0 ) THEN
	    CALL VSDB_ERR ( ier, ' ', irr )
	    iret = -8
	    RETURN
	END IF
	IF ( ilst .eq. 0 ) RETURN
C
C*	Do another round of rough checking using the fields.
C
	CALL SRCH_FLD ( skip, iret )
C*
	RETURN
	END
