	SUBROUTINE SRCH_STT ( itrc, iret )
C************************************************************************
C* SRCH_STT								*
C*									*
C* This subroutine combines single trace data at point locations so	*
C* that the date/times of verification exactly match at all points.	*
C* 									*
C*									*
C* SRCH_STT ( ITRC, IRET )						*
C*									*
C* Input parameters:							*
C*	ITRC		INTEGER		Number of trace			*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*					 +2 = a trace has zero points	*
C*				 	  0 = normal return 		*
C*					 -3 = invalid combination code	*
C**									*
C* Log:									*
C* K. Brill/HPC		12/01						*
C* K. Brill/HPC		10/02	Set the BINMTY array for conditionally	*
C*				determined ind. variable points		*
C************************************************************************
	INCLUDE		'srch.cmn'
C*
	REAL*8			rhold (MXDPTH), r1, rn
	CHARACTER*(NCKCHR)	dtmsv
C*-----------------------------------------------------------------------
	iret = 0
	ntotl = 0
C
C*	Starting with the first point on the trace, scan all CONCHK
C*      elements.  Each must occur the same number of times at all
C*	trace points.
C
	DO i = 1, nxtelm (itrc)
	    dtmsv = conchk (itrc,i)
	    icnt = 0
	    DO mtp = 1, ndatap (itrc)
		DO inxm = 1, nxtelm (itrc)
		    IF ( kpoint (itrc,inxm) .eq. mtp ) THEN
			IF ( conchk (itrc,inxm) .eq. dtmsv ) THEN
			    icnt = icnt + 1
			END IF
		    END IF
		END DO
	    END DO
	    IF ( MOD ( icnt, ndatap (itrc) ) .eq. 0 ) THEN
C
C*		Set all KPOINT values to negative to flag this CONCHK.
C
		DO mtp = 1, ndatap (itrc)
		    DO inxm = 1, nxtelm (itrc)
			IF ( kpoint (itrc,inxm) .eq. mtp ) THEN
			    IF ( conchk (itrc,inxm) .eq. dtmsv ) THEN
				kpoint (itrc,inxm) = -kpoint (itrc,inxm)
			    END IF
			END IF
		    END DO
		END DO
	    END IF
	END DO
C
C*	Now combine data for all points where KPOINT is negative.
C
	iaccp = 0
	ndat = 0
	DO ipnt = 1, ndatap (itrc)
	    DO jd = 1, ndepth (itrc)
		rhold (jd) = 0.0
	    END DO
	    in = 0
	    icnt = 0
	    DO WHILE ( in .lt. nxtelm (itrc) .and.
     +		       icnt .lt. kounts (itrc,ipnt) )
		in = in + 1
		IF ( kpoint (itrc,in) .eq. -ipnt ) THEN
			iaccp = iaccp + 1
			iswap = in
			dtmsv = conchk (itrc,in)
			icnt = icnt + 1
			IF ( kdvcmb (itrc) .eq. 0 ) THEN
			    DO jd = 1, ndepth (itrc)
				rhold (jd) = dtrace (itrc,jd,in)
			    END DO
			ELSE IF ( kdvcmb (itrc) .eq. 1 ) THEN
			    DO jd = 1, ndepth (itrc)
				rhold (jd) = rhold (jd) +
     +						 dtrace (itrc,jd,in)
			    END DO
			ELSE IF ( kdvcmb (itrc) .eq. 2 ) THEN
			    DO jd = 1, ndepth (itrc)
				IF ( jd .eq. indxdc (itrc) ) THEN
				    rhold (jd) = rhold (jd) +
     +						     dtrace (itrc,jd,in)
				ELSE
				    r1 = dtrace (itrc,indxdc(itrc),in)
				    rn = dtrace (itrc,jd,in)
				    rhold (jd) = rhold (jd) + r1 * rn
				END IF
			    END DO
			ELSE 
			    iret = -3
			    RETURN
			END IF
		END IF
	    END DO
	    IF ( icnt .gt. 0 ) THEN
		ndat = ndat + 1
		DO jd = 1, ndepth (itrc)
		    dtrace (itrc,jd,iswap) = dtrace (itrc,jd,ndat)
		    dtrace (itrc,jd,ndat) = rhold (jd)
		END DO
		conchk (itrc,iswap) = conchk (itrc,ndat)
		conchk (itrc,ndat) = dtmsv
		kpoint (itrc,iswap) = kpoint (itrc,ndat)
		kpoint (itrc,ndat) = ipnt
C
C*		Set counts and labels for this point.
C
		kounts (itrc,ndat) = icnt
		ctrcid (itrc,ndat) = ctrcid (itrc,ipnt)
		rtrcid (itrc,ndat) = rtrcid (itrc,ipnt)
	    ELSE IF ( kivnpt (itrc) .gt. 1 ) THEN
		binmty (itrc,ipnt) = .true.
	    END IF
	END DO
C
C*	Set final data count for this trace.
C
	ndatap (itrc) = ndat
	ntotl = ntotl + ndat
	IF ( ndat .eq. 0 ) iret = +2
	kaccpt (itrc) = iaccp
C*
	RETURN
	END
