	SUBROUTINE SRCH_TCN ( icode, ifeld, iret )
C************************************************************************
C* SRCH_TCN								*
C*									*
C* This subroutine performs a test to see if the condition code is	*
C* valid.  Result is returned in IRET.					*
C*									*
C* SRCH_TCN ( ICODE, IFELD, IRET )					*
C*									*
C* Input parameters:							*
C*	ICODE		INTEGER		Comparison condition type #	*
C*	IFELD		INTEGER		Descriptor/data field element #	*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					-18 = real cond is invalid	*
C*					-19 = char cond is invalid	*
C*					-21 = field # is invalid	*
C**									*
C* Log:									*
C* K. Brill/EMC		 7/97						*
C* K. Brill/EMC		10/97	Check for field 15 (HHNN)		*
C************************************************************************
	INCLUDE		'srch.cmn'
C*
	LOGICAL		ok
C*
C*------------------------------------------------------------------------
	iret = 0
C*
	IF ( ifeld .eq. 2 ) THEN
C
C*	    Checking the model being verified.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C*
	ELSE IF ( ifeld .eq. 5 .or. ifeld .eq. 15 ) THEN
C
C*	    Checking verification time.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C*
	ELSE IF ( ifeld .eq. 8 ) THEN
C
C*	    Checking the verifying analysis.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C*
	ELSE IF ( ifeld .eq. 9 ) THEN
C
C*	    Checking the verifying region.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C*
	ELSE IF ( ifeld .eq. 10 ) THEN
C
C*	    Checking the statistic type.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C*
	ELSE IF ( ifeld .eq. 12 ) THEN
C
C*	    Checking the parameter name.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C*
	ELSE IF ( ifeld .eq. 13 ) THEN
C
C*	    Checking the level identifier.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .lt. 10 ) THEN
		iret = -18
		RETURN
	    END IF
C
C*	Add future descriptor field checks here.
C
C*
	ELSE IF ( ifeld .gt. 100 ) THEN
C
C*	    Checking a datam value.
C
	    ok = icode .eq. 0
	    IF ( .not. ok .and. icode .ge. 10 ) THEN
		iret = -19
		RETURN
	    END IF
	ELSE IF ( ifeld .le. 0 ) THEN
	    iret = -21
	END IF
C*
	RETURN
	END
