	SUBROUTINE STX_FRSS ( mxt, mxd, ndpth, npts, itrc, dtrace,
     +			      rmiss, trcdat, trcmin, trcmax, iret )
C************************************************************************
C* STX_FRSS								*
C*									*
C* This subroutine computes the Fractions Skill Score (FSS) for FSS	*
C* spatial technique statistic type records.				*
C*									*
C*									*
C* STX_FRSS ( MXT, MXD, NDPTH, NPTS, ITRC, DTRACE,			*
C*	      RMISS, TRCDAT, TRCMIN, TRCMAX, IRET )			*
C*									*
C* Input parameters:							*
C*	MXT		INTEGER		Max # of traces in DTRACE	*
C*	MXD		INTEGER		Max # of values/point in DTRACE	*
C*	NDPTH		INTEGER		# of values per trace point	*
C*	NPTS		INTEGER		Number of points in the trace	*
C*	ITRC		INTEGER		Trace #				*
C*	DTRACE (MXT,MXD,						*
C*		NPTS)	REAL*8		Trace values			*
C*	RMISS		REAL		Missing value for output	*
C*									*
C*									*
C* Output parameters:							*
C*	TRCDAT (NPTS)	REAL*8		Output trace			*
C*	TRCMIN		REAL		Minimum output trace value	*
C*	TRCMAX		REAL		Maximum output trace value	*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C*					 -1 = Computation not possible	*
C**									*
C* Log:									*
C* K. Brill/HPC	     20090514						*
C************************************************************************
	REAL*8		dtrace (mxt,mxd,*), trcdat (*)
C*
	REAL*8		rn
	LOGICAL		ok
C*-----------------------------------------------------------------------
	iret = 0
	IF ( ndpth .lt. 4 ) THEN
	    iret = -1
	    RETURN
	END IF
C*
	trcmin = 1.1E30
	trcmax = -1.1E30
	DO ip = 1, npts
	    IF ( dtrace (itrc,1,ip) .gt. 0.0 ) THEN
		ok = ( dtrace (itrc,2,ip) .gt. 0.0 )
		ok = ( ok .and. dtrace (itrc,3,ip) .gt. 0.0 )
		ok = ( ok .and. dtrace (itrc,4,ip) .gt. 0.0 )
		rn = dtrace (itrc,3,ip) + dtrace (itrc,4,ip)
		IF ( ok ) THEN
		    trcdat (ip) = 1.0 - dtrace (itrc,2,ip) / rn
 		    IF ( trcdat (ip) .lt. trcmin ) THEN
                        trcmin = trcdat (ip)
                    END IF
                    IF ( trcdat (ip) .gt. trcmax ) THEN
                        trcmax = trcdat (ip)
                    END IF
		ELSE
		    trcdat (ip) = rmiss
		END IF
	    ELSE
		trcdat (ip) = rmiss
	    END IF
C*
	END DO
C*
	RETURN
	END
