	SUBROUTINE USR_ENCD ( r, n, cout, iret )
C************************************************************************
C*  USR_ENCD								*
C*									*
C*  This subroutine encodes a 64-bit real into a 7-character string,	*
C*  preserving 11 decimal significant digits of precision.		*
C*									*
C*  USR_ENCD ( R, N, COUT, IRET )					*
C*									*
C*  Input parameters:							*
C*	R (N)		REAL*8		Input real numbers		*
C*	N		INTEGER		Number of real numbers		*
C*									*
C*  Output parameters:							*
C*	COUT (N)	CHAR*7		Output strings of encoded data	*
C*	IRET		INTEGER		Return code			*
C*									*
C* Log:									*
C* K. Brill/EMC		 9/97						*
C* K. Brill/EMC		12/97	Fixed line feed character bug		*
C************************************************************************
	REAL*8		r (*)
	CHARACTER*7	cout (*)
C*
	CHARACTER*20	etyp
C------------------------------------------------------------------------
	iret = 0
	DO i = 1, n
	    WRITE (etyp, '(D20.12)' ) r (i)
	    iminus = INDEX ( etyp (1:5), '-' )
	    iperio = INDEX ( etyp (1:6), '.' )
	    iexp = INDEX ( etyp, 'D' ) + 1
	    IF ( iexp .eq. 1 ) THEN
	        iexp = INDEX ( etyp, 'E' ) + 1
	    END IF
	    IF ( iminus .eq. 0 ) then
		iminus = 1
	    ELSE
		iminus = -1
	    END IF
	    is = iperio + 1
	    ie = iperio + 2
	    READ ( etyp(is:ie), '(I2)' ) ic
	    ic = ic + 14
	    IF ( iminus .lt. 0 ) ic = 127 + IABS (ic)
	    cout (i) (1:1) = CHAR (ic)
	    DO iq = 2, 6
	        is = ie + 1
	        ie = is + 1
		READ ( etyp(is:ie), '(I2)' ) ic
		ic = ic + 14
		cout (i) (iq:iq) = CHAR (ic)
	    END DO
	    READ ( etyp(iexp: ), '(I4)' ) ix
	    IF ( ix .lt. 0 ) THEN
		iminus = -1
	    ELSE
		iminus = 1
	    END IF
	    ix = IABS (ix) + 14
	    IF ( iminus .lt. 0 ) ix = 127 + IABS (ix)
	    cout (i) (7:7) = CHAR (ix)
	END DO
	RETURN
	END
