	SUBROUTINE USR_FMPN ( lun, maxpnm, iret )
C************************************************************************
C*  USR_FMPN								*
C*									*
C*  This subroutine searches a control file or a trace data file	*
C*  for the purpose of counting the number of plots (individual 	*
C*  frames) defined therein.						*
C*									*
C*  USR_FMPN ( LUN, MAXPNM, IRET )					*
C*									*
C*  Input parameters:							*
C*	LUN		INTEGER		Unit number connected to file	*
C*									*
C*  Output parameters:							*
C*	MAXPNM		INTEGER		Number of plots defined		*
C*	IRET		INTEGER		Return code			*
C*					 -1 = invalid header record	*
C*					 -2 = too few condition recs	*
C*					 -6 = file rewind failed	*
C*									*
C* Log:									*
C* K. Brill/EMC		10/97						*
C************************************************************************
C*
	CHARACTER*128	inrec
	INTEGER		ihdr (7)
C------------------------------------------------------------------------
	iret = 0
	maxpnm = 0
C*
	REWIND ( UNIT=lun, IOSTAT=ios )
	IF ( ios .ne. 0 ) THEN
	    iret = -6
	    RETURN
	END IF
	inrec = ' '
	DO WHILE ( ios .eq. 0 )
	    READ (lun,'(A)',IOSTAT=ios) inrec
	    ios = ios + INDEX ( inrec, 'EOCF' )
	    IF ( ios .eq. 0 ) THEN
		CALL ST_ILST ( inrec, ' ', -99, 7, ihdr, num, ier )
		IF ( num .ne. 7 .or. ier .lt. 0 ) THEN
		    iret = -1
		    RETURN
		END IF
		IF ( ihdr (6) .gt. maxpnm ) maxpnm = ihdr (6)
		ncn = ihdr (5)
		DO i = 1, ncn
		    READ (lun,'(A)',IOSTAT=ios) inrec
		    IF ( ios .ne. 0 ) THEN
			iret = -2
			RETURN
		    END IF
		END DO
	    END IF
	END DO
	RETURN
	END
