	SUBROUTINE VSDB_ERR ( i, usrmsg, iret )
C************************************************************************
C* VSDB_ERR								*
C*									*
C* This subroutine writes a Verification Statistic Database (VSDB)	*
C* software error message.						*
C*									*
C* The USRMSG is not printed if it is blank.				*
C*									*
C* VSDB_ERR  ( I, USRMSG, IRET )					*
C*									*
C* Input parameters:							*
C*	I		INTEGER		Value of a return code		*
C*	USRMSG		CHAR*		User reference message		*
C*									*
C* Output parameters:							*
C*	IRET		INTEGER		Return code			*
C*				 	  0 = normal return 		*
C**									*
C* Log:									*
C* K. Brill/NMC		 7/97						*
C* K. Brill/HPC		 2/04	Add -17 error				*
C************************************************************************
	CHARACTER*(*)	usrmsg
C*
C*------------------------------------------------------------------------
	iret = 0
	IF ( usrmsg .ne. ' ' ) THEN
	    WRITE (6,*) usrmsg
	END IF
	IF ( i .eq. 3 ) WRITE (6,*)
     +		 '+03 = More than NVAL data values'
	IF ( i .eq. 2 ) WRITE (6,*)
     +		 '+02 = End of file encountered'
	IF ( i .eq. 1 ) WRITE (6,*)
     +		 '+01 = Data field is blank'
	IF ( i .eq. 0 ) WRITE (6,*)
     +		 '  0 = normal return'
	IF ( i .eq. -1 ) WRITE (6,*)
     +		  '-01 = invalid I/O type'
	IF ( i .eq. -2 ) WRITE (6,*)
     +		  '-02 = file does not exist'
	IF ( i .eq. -3 ) WRITE (6,*)
     +		  '-03 = error opening existing file'
	IF ( i .eq. -4 ) WRITE (6,*)
     +		  '-04 = error opening new file'
	IF ( i .eq. -5 ) WRITE (6,*)
     +		  '-05 = invalid record from VSDB file'
	IF ( i .eq. -6 ) WRITE (6,*)
     +		  '-06 = invalid version number'
	IF ( i .eq. -7 ) WRITE (6,*)
     +		  '-07 = invalid number of fields'
	IF ( i .eq. -8 ) WRITE (6,*)
     +		  '-08 = invalid forecast hour'
	IF ( i .eq. -9 ) WRITE (6,*)
     +		  '-09 = invalid verifying time'
	IF ( i .eq. -10 ) WRITE (6,*)
     +		   '-10 = invalid threshold set'
	IF ( i .eq. -11 ) WRITE (6,*)
     +		   '-11 = invalid accum period'
	IF ( i .eq. -12 ) WRITE (6,*)
     +		   '-12 = invalid level id'
	IF ( i .eq. -13 ) WRITE (6,*)
     +		   '-13 = invalid data field'
	IF ( i .eq. -14 ) WRITE (6,*)
     +		   '-14 = read error'
	IF ( i .eq. -15 ) WRITE (6,*)
     +		   '-15 = LUN has not been opened'
	IF ( i .eq. -16 ) WRITE (6,*)
     +		   '-16 = 0 fields requested'
	IF ( i .eq. -17 ) WRITE (6,*)
     +		   '-17 = Substitution not allowed in 1st VSDB rcrd.'
C*
	RETURN
	END
