	SUBROUTINE VSDB_SLN ( string, sep, sdef, nexp, sarr, num, iret )
C************************************************************************
C* VSDB_SLN								*
C*									*
C* This subroutine breaks a string containing a list of strings into an	*
C* array of string values.  The separator for the strings is input as 	*
C* SEP.  Repeated separators are regarded as a single separator.	*
C* If a value cannot be determined from the substring between two	*
C* separators, the default string is assigned.				*
C*									*
C* VSDB_SLN  ( STRING, SEP, SDEF, NEXP, SARR, NUM, IRET )		*
C*									*
C* Input parameters:							*
C*	STRING		CHAR*		String				*
C*	SEP		CHAR*1		Separator			*
C*	SDEF		CHAR*		Default string			*
C*	NEXP		INTEGER		Number of expected strings 	*
C*									*
C* Output parameters:							*
C*	SARR  (NUM)	REAL		Array of string values		*
C*	NUM		INTEGER		Number of values returned	*
C*	IRET		INTEGER		Return code			*
C*				   	  0 = normal return		*
C**									*
C* Log:									*
C* M. Goodman/RDS	10/84	Original source for STLIST		*
C* M. desJardins/GSFC	11/84						*
C* M. desJardins/GSFC	 2/85	Modified for ST_RLST			*
C* M. desJardins/GSFC	 6/88	Documentation				*
C* L. Sager/NCEP         2/96   Increased size of strbuf                *
C* K. Brill/HPC		 3/04	Completely rewrote			*
C************************************************************************
	CHARACTER*(*)	string, sep, sdef, sarr (*)
C*
	CHARACTER	cchar*1
	LOGICAL		more
C------------------------------------------------------------------------
	iret = 0
	num  = 0
	cchar = sep
C
C*	Initialize output array.
C
	DO  i = 1, nexp
	    sarr (i) = sdef
	END DO
C
C*	Get the length of the input string.
C
	CALL ST_LSTR ( string, lns, ier )
	IF ( lns .eq. 0 ) RETURN
C
C*	Loop over all substrings bounded by the separater.
C
	indx = 1
	DO WHILE ( string (indx:indx) .eq. cchar .and. indx .lt. lns )
	    indx = indx + 1
	END DO
	is = indx
	next = INDEX ( string(is:lns), cchar )
	next = is + next - 1
	more = .true.
	DO WHILE ( more .and. is .le. lns )
	    num = num + 1
	    nm1 = next - 1
	    iq = nm1 - is
	    IF ( iq .ge. 0 ) THEN
		sarr (num) = string (is:nm1)
	    ELSE
		sarr (num) = sdef
	    END IF
	    is = next + 1
	    DO WHILE ( string (is:is) .eq. cchar .and. is .lt. lns )
		is = is + 1
	    END DO
	    IF ( is .le. lns ) THEN
		next = INDEX ( string (is:lns), cchar )
		IF ( next .ne. 0 ) THEN
		    next = is + next - 1
		ELSE
		    next = lns + 1
		END IF
	    END IF
	    IF ( num .eq. nexp ) THEN
		more = .false.
	    END IF
	END DO
C*
	RETURN
	END
